(* ::Package:: *)

(* ::Title:: *)
(*FSM*)


(* ::Text:: *)
(*Author:               Klaus Sutner*)
(*Affiliation: 	Carnegie Mellon University*)
(*email:       		sutner@cs.cmu.edu*)
(*url:         		http://www.cs.cmu.edu/~sutner*)
(*version:     	11.2*)


(* ::Section::Closed:: *)
(*Header*)


BeginPackage["Automata11`fsm`",{"Automata11`utils`"}];


GreenRel::usage = "GreenRel is an option for GenerateSemigroup.";
Multiplicity::usage = "Multiplicity is an option for LanguageFA.";
Matrix::usage = "Matrixc is an option value (Type for TSys).";
Type::usage = "Type is an option for various commands.";
SubType::usage = "SubType is an option for various commands.";
$defaultnormalize::usage = "$defaultnormalize is the default value for option Normalize.";
Normalize::usage = "Normalize is a default value controlling normalization (Full, Automatic, None).";
$alphabet::usage = "$alphabet is a default alphabet.";
Simple::usage = "Simple is an option for TransitionsToEdges.";
Props::usage = "Props is an option for finite state machines (currently a stub).";
Labels::usage = "Labels is an option for CirculantFA.";
Trim::usage = "Trim is an option for TrimFA, PlotFA.";
Accessible::usage = "Accessible is an option value for TrimFA.";
Coaccessible::usage = "Coacessible is an option value for TrimFA.";
DoTrace::usage = "DoTrace is an option for various commands.";
EpsElim::usage = "EpsElim is an option for EpsilonEliminationFA.";
Printable::usage = "Printable is an option for Alpha.";
AlphabetOffset::usage = "AlphabetOffset is an option for Alpha.";
Letter::usage = "Letter is an optionvalue for Alpha.";
Digit::usage = "Digit is an optionvalue for Alpha.";
States::usage = "States is an option for TSys.";
StatesNorm::usage = "StatesNorm is an optionvalue for TSys.";
AlphabetNorm::usage = "AlphabetNorm is an optionvalue for TSys.";
Sorted::usage = "Sorted is an option for FullProductTransition.";
Strict::usage = "Strict is an option for FullProductTransition.";
SizeOnly::usage = "SizeOnly is an option for LanguageFA.";
Terminal::usage = "Terminal is an option for CondensationGraph.";
Words::usage = "Words[r,K]  produces a list of words of length r over alphabet K. ";
VertexTransformation::usage = "VertexTransformation is an option for TransitionsToGraph.";
LabelTransformation::usage = "LabelTransformation is an option for TransitionsToGraph.";
Alpha::usage = "Alpha[k,opts] represents an alphabet of cardinality k in a transition system.";
GetAlphabet::usage = "GetAlphabet[T] returns the alphabet of transition system T.";
AlphabetCount::usage = "AlphabetCount[A] returns the number of symbols in an alphabet.";
AlphabetTracks::usage = "AlphabetTracks[A] returns a list of the tracks in an alphabet.";
AlphabetTrackCount::usage = "AlphabetTrackCount[A] returns the number of tracks in an alphabet.";
AlphabetList::usage = "AlphabetList[A] returns a list of printable versions of symbols in an alphabet, when applicable.";
Eps::usage = "Eps represents the empty word over any alphabet.";
EpsQ::usage = "EpsQ[x] tests whether x represents the empty word.";
WordQ::usage = "WordQ[x] tests whether x is a word.";
ToWord::usage = "ToWord[w,A] converts index list w into a printable word over alphabet A.";
ToIndex::usage = "ToIndex[w,A] converts word w over alphabet A into an index list.";
Randomword::usage = "RandomWord[k,A] generates a random word of length at most k over alphabet A.";
WordBinomial::usage = "WordBinomial[u,v,opts] determines the word binomial of u and v.";
WordLength::usage = "WordLength[w] returns the length of word w.";
WordSort::usage = "WordSort[L] sorts a list of words L in length-lex order.";
WordShuffle::usage = "WordShuffle[u,v] generates the shuffle of words u and v.";
TSys::usage = "TSys[n,k,t,tr,K,opts] represents a transition system over alphabet K.";
TransitionSource::usage = "TransitionSource[t] returns the source of transistion t.";
TransitionLabel::usage = "TransitionLabel[t] returns the Label of transistion t.";
TransitionTarget::usage = "TransitionTarget[t] returns the Target of transistion t.";
TransitionCount::usage = "TransitionCount[T] returns the number of transitions of a transition system T.";
TransitionsRaw::usage = "TransitionsRaw[T] returns the transistions of a transition system T unmodified.";
TransitionList::usage = "TransitionList[T] returns the transistions of a transition system T.";
StateCount::usage = "StateCount[T] returns the number of states of a transition system T.";
StateList::usage = "StateList[T] returns the list of states of a transition system T.";
SetTransitionSystem::usage = "SetTransitionSystem[M,T] sets the transition system of automaton M to T.";
SetStates::usage = "SetStates[T,Q] sets the states of a transition system T to Q.";
SetAlphabet::usage = "SetAlphabet[T,A] sets the alphabet of a transition system T to A.";
StateDelete::usage = "StateDelete[T,p,opts] removes state p from a transition system T.";
EpsilonFreeQ::usage = "EpsilonFreeQ[T] checks whether transition system T is epsilon-free.";
FullProductTransitions::usage = "FullProductTransitions[T1,T2] generates the product of transition lists T1 and T2.";
ProductTransitionSystem::usage = "ProductTransitionSystem[T1,T2] generates the product of transition systems T1 and T2.";
MapTransitions::usage = "MapTransitions[tr,f,g] applies functions f and g to states and symbols in transition list tr.";
TransitionFunctionList::usage = "TransitionFunctionList[ff,T] assigns to symbol list ff the curried transition functions of transitions system T.";
AssignTransitionFunction::usage = "AssignTransitionFunction[del,T] assigns to symbol del the transition function of transition system T.
Use option Full->True to deal with sets of states.";
TransitionMatrix::usage = "TransitionMatrix[T] constucts the transition matrix of transitions system T.";
TransitionsToSparse::usage = "TransitionsToSparse[T] constucts the sparse transition matrix of transitions system T.";
TransitionToBooleanMatrix::usage = "TransitionToBooleanMatrix[T] constucts the Boolean transition matrix of transitions system T.";
SubTransitionSystem::usage = "SubTransitionSystem[T,P] constucts the sub-transitions system of T induced by P.";
ReverseTransitions::usage = "ReverseTransitions[T] constucts the reversal of the transitions system T.";
FSMQ::usage = "FSMQ[M] checks whether M is a finite state machine (Head comparison only).";
AccCond::usage = "AccCond[args] represents the acceptance condition of an automaton A.";
FA::usage = "FA[args] represents a non-deterministic automaton.";
DFA::usage = "DFA[args] represents a deterministic complete automaton.";
TD::usage = "TD[args] represents a transducer.";
TransitionSystem::usage = "TransitionSystem[A] returns the transition system of an automaton A.";
InitialStateList::usage = "InitialStateList[T] returns the list of states of a transition system T (normalized).";
InitialState::usage = "InitialState[M] returns the initial state of a DFA M (normalized).";
FinalStateList::usage = "StateList[T] returns the list of states of a transition system T (normalized).";
TrapStateList::usage = "TrapStateList[M] returns the list of trap states of automaton M.";
TypeFSM::usage = "TypeFSM[A] returns the type of automaton A.";
TrimStateList::usage = "TrimStateList[M,opts] returns a list of the states in the (accessible, coaccessible, trim) part of automaton M.";
TrimFA::usage = "TrimFA[M,opts] returns the (accessible, coaccessible, trim) part of automaton A.";
ToFA::usage = "ToFA[M] converts the automaton M to an FA.";
SetInitialFA::usage = "SetInitialFA[M,I] sets the initial states of an automaton M.";
SetFinalFA::usage = "SetFinalFA[M,F] sets the final states of an automaton M.";
SetInitialFinalFA::usage = "SetInitialFinalFA[M,I,F] sets the initial and final states of an automaton M.";
ToAllFA::usage = "ToAllFA[M] replaces sets of initial and final states in M by All where appropriate.";
SubFA::usage = "SubFA[M,P] generates the subautomaton induced by state set P.";
UniversalDFA::usage = "UniversalDFA[A] constucts the universal automaton for alphabet A.";
GenerateFA::usage = "GenerateFA[Q0,{f,g,..},A,fin]  constructs a DFA on the closure Q of Q0 under {f,g,...} over alphabet A.\
Predicate fin selects the final states in Q. {f,g,...} must have length the size of A.";
SemilinearDFA::usage = "SemilinearDFA[w,{t,p,A,B},K,opts] constucts a counter automaton for word w and semilinear set (t,p,A,B) over alphabet A.";
PositionFA::usage = "PositionFA[a,p,A,opts] constucts the x[p]=a automaton for alphabet A.";
CirculantFA::usage = "CirculantFA[n,{s1,...,sk],opts] constucts the circulant automaton on n states with strides 
s1, ..., sk.";
ToFactorFA::usage = "ToFactorFA[M,opts]  converts a FSM M into a machine that accepts the language of all factors of words in the language of M.";
ToFrontierDFA::usage = "ToFrontierDFA[M,opts]  converts DFA M into the corresponding frontier automaton (g,F).";
TransitionsToEdges::usage = "TransitionsToEdges[t,opts] converts a transition to a directed edge.";
TransitionsToGraph::usage = "TransitionsToGraph[t,opts] converts a finite state machine to a directed graph.";
NonTrivialComponentQ::usage = "NonTrivialComponentQ[G,L] tests whether vertex set L represents a non-trivial component of G.";
CondensationGraph::usage = "CondensationGraph[G] computes the condensation of digraph G.";
ShowGraph::usage = "ShowGraph[G,opts] displays the graph G.";
TD::usage = "TD[args] represents a transducer.";
ApplyTransduction::usage = "ApplyTransduction[T,L,opts] applies transduction defined by T to word L.";
AssignTransduction::usage = "AssignTransduction[t,T,opts] assigns transduction defined by T to symbol t.";
ToKernelFA::usage = "ToKernelFA[A,K,opts] generates the K kernel automaton of A.";
TestPropertyFA::usage = "TestPropertyFA[A,P,opts] tests automaton A for property P.";
ReverseFA::usage = "ReverseFA[M] constucts the reversal of the automaton M.";
EpsilonEliminationFA::usage = "EpsilonEliminationFA[M]  removes eps-transitions from the automaton M.";
DeterminizeFA::usage = "DeterminizeFA[M]  determinizes the finite state machine M.";
LanguageFA::usage = "LanguageFA[M,n,opts] returns the part of the language of automaton A.";
MinimizeFA::usage = "MinimizeFA[M,opts]  minimizes the finite state machine M. May involve determinization.";
MinimizeDFA::usage = "MinimizeDFA[M,opts]  minimizes the DFA M.";
ComplementFA::usage = "ComplementFA[M]  generates a DFA that accepts the complement of the acceptance language of machine M.";
ConcatenateFA::usage = "ConcatenateFA[M]  generates a DFA that accepts the complement of the acceptance language of machine M.";
StarFA::usage = "StarFA[M]  generates a DFA that accepts the complement of the acceptance language of machine M.";
IntersectionFA::usage = "IntersectionFA[M1,M2]  generates the intersection automaton for M1 and M2.";
ProductFA::usage = "ProductFA[M1,M2]  generates the product automaton for M1 and M2.";
UnionFA::usage = "UnionFA[M1,M2]  generates the sum automaton for M1 and M2.";
ShuffleProductFA::usage = "ShuffleProductFA[M1,M2,opts]  generates the shuffle product automaton for M1 and M2.";
GrowthFunctionDFA::usage = "GrowthSeriesDFA[M,x] returns a generating function for the growth function of M.";
EmptyQFA::usage = "EmptyQFA[M] checks whether the language of M is empty.";
FiniteQFA::usage = "FiniteQFA[M] checks whether the language of M is finite.";
DeterministicQFA::usage = "DeterministicQFA[M] checks whether eps-free automaton M is deterministic.";
DefiniteQDFA::usage = "DefiniteQDFA[M] checks whether the language of M is definite.";
UniversalQFA::usage = "UniversalQFA[M] checks whether the language of M is universal.";
EquivalentQFA::usage = "EquivalentQFA[M1,M2] checks whether automata M1 and M2 are equivalent.";
IsomorphicQDFA::usage = "IsomorphicQDFA[M1,M2] checks whetherthe DFAs M1 and M2 are isomorphic.";
CoverQDFA::usage = "CoverQDFA[M1,M2,opts] checks whetherthe DFAs M1 and M2 are isomorphic.";
AssignHomomorphismDFA::usage = "AssignHomomorphismDFA[M1,M2] tries to construct a homomorphism from DFA M1 to DFA M2.";
$regexrules::usage = "$regexrules is a collection of rewrite rules for regular expressions.";
SGT::usage = "SGT[L] denotes the transformation given by list L.";
SemigroupProduct::usage = "SemigroupProduct[x,y] computes the product of transformations x and y.";
SemigroupPower::usage = "SemigroupPower[T,k] computes T^k for a transformation T.";
TransformationQ::usage = "TransformationQ[L] checks whether list L can be interpreted as a transformation.";
PermutationToTransformation::usage = "PermutationToTransformation[p,n] returns the rank n transformation corresponding to permutation p.";
ToTransformationsDFA::usage = "ToTransformationsDFA[M] returns the transformations corresponding to DFA M.";
GenerateSemigroup::usage = "GenerateSemigroup[{t1,..,tk},opts] returns the semigroup generated by transformations t1,...,tk.";
ConstructFA::usage = "ConstructFA[args,opts] constructs a FSM from parameters. Type: Empty, Universal, Quotient.";
SemigroupDegree::usage = "SemigroupDegree[T] returns the degree of transformation T.";
WordOrder::usage = "WordOrder[u,v] returns the trit indicating the order of words u and v.";
TransitionDelete::usage = "TransitionDelete[M,p,s,q] removes transition {p,s,q} from automaton M.";
TransitionAdd::usage = "TransitionAdd[M,p,s,q] adds transition {p,s,q} to automaton M."
Concatenate::usage = "Concatenate[x,y] returns the concatenation of words x and y.";




Begin["`Private`"];


(* ::Section::Closed:: *)
(*Options*)


PackageSymbol[$defaultnormalize,
"$defaultnormalize is the default value for option Normalize."];


PackageSymbol[GreenRel,
"GreenRel is an option for GenerateSemigroup."];


PackageSymbol[Normalize,
"Normalize is a default value controlling normalization (Full, Automatic, None)."];


PackageSymbol[$alphabet,
"$alphabet is a default alphabet."];


PackageSymbol[Simple,
"Simple is an option for TransitionsToEdges."];


PackageSymbol[Props,
"Props is an option for finite state machines (currently a stub)."];


PackageSymbol[Labels,
"Labels is an option for CirculantFA."];


PackageSymbol[Trim,
"Trim is an option for TrimFA, PlotFA."];


PackageSymbol[Accessible,
"Accessible is an option value for TrimFA."];


PackageSymbol[Coaccessible,
"Coacessible is an option value for TrimFA."];


PackageSymbol[DoTrace,
"DoTrace is an option for various commands."];


PackageSymbol[EpsElim,
"EpsElim is an option for EpsilonEliminationFA."];


PackageSymbol[Type,
"Type is an option for various commands."];


PackageSymbol[Printable,
"Printable is an option for Alpha."];


PackageSymbol[AlphabetOffset,
"AlphabetOffset is an option for Alpha."];


PackageSymbol[Multiplicity,
"Multiplicity is an option for LanguageFA."];


PackageSymbol[Letter,
"Letter is an optionvalue for Alpha."];


PackageSymbol[Digit,
"Digit is an optionvalue for Alpha."];


PackageSymbol[States,
"States is an option for TSys."];


PackageSymbol[StatesNorm,
"StatesNorm is an optionvalue for TSys."];


PackageSymbol[AlphabetNorm,
"AlphabetNorm is an optionvalue for TSys."];


PackageSymbol[Sorted,
"Sorted is an option for FullProductTransition."];


PackageSymbol[Strict,
"Strict is an option for FullProductTransition."];


PackageSymbol[SizeOnly,
"SizeOnly is an option for LanguageFA."];


PackageSymbol[Terminal,
"Terminal is an option for CondensationGraph."];


PackageSymbol[VertexTransformation,
"VertexTransformation is an option for TransitionsToGraph."];


PackageSymbol[LabelTransformation,
"LabelTransformation is an option for TransitionsToGraph."];


(* ::Section::Closed:: *)
(*Alphabets*)


(* ::Subsection::Closed:: *)
(*Alpha*)


PackageSymbol[Alpha,
"Alpha[k,opts] represents an alphabet of cardinality k in a transition system."];


SyntaxInformation[Alpha] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[Alpha]={Type->Letter,AlphabetOffset->0,Printable->None};
AllOptions[Alpha]={Type->{Letter,Digit,_List},AlphabetOffset->{0,_Integer}};


$alphabet = Alpha[2];


(* ::Subsection::Closed:: *)
(*GetAlphabet*)


PackageSymbol[GetAlphabet,
"GetAlphabet[T] returns the alphabet of transition system T."];


SyntaxInformation[GetAlphabet] = {"ArgumentsPattern"->{_}};
Attributes[GetAlphabet]={Listable};
GetAlphabet[T_TSys] := T[[5]];                (* critical *)
GetAlphabet[M_?FSMQ] := GetAlphabet@TransitionSystem[M];            


(* ::Subsection::Closed:: *)
(*AlphabetCount*)


PackageSymbol[AlphabetCount,
"AlphabetCount[A] returns the number of symbols in an alphabet."];


SyntaxInformation[AlphabetCount] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[AlphabetCount]={Full->False};
Attributes[AlphabetCount]={Listable};


AlphabetCount[ Alpha[k_Integer,___], opts:OptionsPattern[]] := 
	If[ OptionValue[Full], {k}, k ];
AlphabetCount[ Alpha[k:{__Integer},___], opts:OptionsPattern[]] := 
	If[ OptionValue[Full], k, Times@@k ];
AlphabetCount[ts_TSys,opts:OptionsPattern[]] := AlphabetCount[GetAlphabet[ts],opts];          (* critical *)
AlphabetCount[M_?FSMQ,opts:OptionsPattern[]] := AlphabetCount[GetAlphabet[M],opts];          (* critical *)


(* ::Subsection::Closed:: *)
(*AlphabetTracks*)


PackageSymbol[AlphabetTracks,
"AlphabetTracks[A] returns a list of the tracks in an alphabet."];


SyntaxInformation[AlphabetTracks] = {"ArgumentsPattern"->{_}};
Attributes[AlphabetTracks]={Listable};
AlphabetTracks[Alpha[k_Integer,___]] := {k};
AlphabetTracks[Alpha[kk:{_Integer..},___]] := kk;
AlphabetTracks[ts_TSys] := AlphabetTracks[ts[[5]]];          (* critical *)
AlphabetTracks[M_?FSMQ] := AlphabetTracks[TransitionSystem[M]];          (* critical *)


(* ::Subsection::Closed:: *)
(*AlphabetTrackCount*)


PackageSymbol[AlphabetTrackCount,
"AlphabetTrackCount[A] returns the number of tracks in an alphabet."];


SyntaxInformation[AlphabetTrackCount] = {"ArgumentsPattern"->{_}};
Attributes[AlphabetTrackCount]={Listable};
AlphabetTrackCount[Alpha[k_Integer,___]] := 1;
AlphabetTrackCount[Alpha[kk:{_Integer..},___]] := Length[kk];
AlphabetTrackCount[ts_TSys] := ts[[5]];          (* critical *)
AlphabetTrackCount[M_?FSMQ] := AlphabetTrackCount[TransitionSystem[M]];          (* critical *)


(* ::Subsection::Closed:: *)
(*AlphabetList*)


(* ::Text:: *)
(*get printable symbols*)
(**)
(*should use hex digits for large digit alphabet*)
(*should this be memoized? *)
(*need better way to print tracks*)


PackageSymbol[AlphabetList,
"AlphabetList[A] returns a list of printable versions of symbols in an alphabet, when applicable."];


SyntaxInformation[AlphabetList] = {"ArgumentsPattern"->{_}};
Attributes[AlphabetList]={Listable};

AlphabetList[K_Alpha] := 
Module[{prn,typ,offs,trk,cnts,fstc,res}, 
	prn = GetOptionValue[K,Printable];
	If[ prn=!=None, Return[prn] ];
	cnts = AlphabetCount[K,Full->True];
	trk = AlphabetTrackCount[K];
	typ = GetOptionValue[K,Type];
	offs = GetOptionValue[K,AlphabetOffset];

	If[ Head[typ]=!=List, 
		typ = Table[typ,{trk}]
	];
	If[ Head[offs]=!=List, 
		offs = Table[offs,{trk}]
	];

	res = Reap@Do[  
		fstc = FromCharacterCode[ 97 + offs[[i]] ];
		Sow@If[ typ[[i]] === Letter, 
			CharacterRange[fstc, FromCharacterCode[97+offs[[i]]+cnts[[i]]-1]],
			ToString /@ Range[offs[[i]],offs[[i]]+cnts[[i]]-1]
		],
		{i,trk}
	];
	If[ trk == 1, 
		Flatten[res[[-1,-1]]],
		StringJoin@@@CartesianProduct@@res[[-1,-1]]
	]
];

AlphabetList[M_?FSMQ] := AlphabetList[GetAlphabet[M]];
AlphabetList[T_TSys] := AlphabetList[GetAlphabet[T]];


(* ::Section::Closed:: *)
(*Words*)


(* ::Text:: *)
(*Use  StringXXXX as much as possible, but beware Epsilon. *)


(* ::Subsection::Closed:: *)
(*Epsilon*)


(* ::Text:: *)
(*Alas, multiple representations for epsilon.*)


PackageSymbol[Eps,
"Eps represents the empty word over any alphabet."];


(*Format[Eps] = Global`\[Epsilon];*)


(* ::Subsection::Closed:: *)
(*EpsQ*)


(* ::Text:: *)
(*Testing for epsilon.*)


PackageSymbol[EpsQ,
"EpsQ[x] tests whether x represents the empty word."];


SyntaxInformation[EpsQ] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[EpsQ]={};
AllOptions[EpsQ]={};


EpsQ[Eps|"Eps"|""|Global`\[Epsilon]|"\[Epsilon]"|{}] = True;
EpsQ[_] = False;


(* ::Subsection::Closed:: *)
(*Concatenate*)


(* ::Text:: *)
(*should this also work on list?*)


PackageSymbol[Concatenate,
"Concatenate[x,y] returns the concatenation of words x and y."];


SyntaxInformation[Concatenate] = {"ArgumentsPattern"->{_,__,OptionsPattern[]}};
Attributes[Concatenate]={Listable};
Options[Concatenate]={};
AllOptions[WordLength]={};


Concatenate[_?EpsQ] := "Eps";
Concatenate[x_String]  := x;
Concatenate[xx___, _?EpsQ, yy___] := Concatenate[xx, yy];
Concatenate[xx__String] := StringJoin @@ {xx};


(* ::Subsection::Closed:: *)
(*WordQ*)


(* ::Text:: *)
(*epsilon, index lists,  strings *)


PackageSymbol[WordQ,
"WordQ[x] tests whether x is a word."];


SyntaxInformation[WordQ] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[WordQ]={};
AllOptions[WordQ]={};


WordQ[Eps|""|Global`\[Epsilon]|_String|{___Integer}] = True;
WordQ[_] = False;


(* ::Subsection::Closed:: *)
(*WordLength*)


(* ::Text:: *)
(*is name OK?*)


PackageSymbol[WordLength,
"WordLength[x] returns the length of word x."];


SyntaxInformation[WordLength] = {"ArgumentsPattern"->{_,_.,OptionsPattern[]}};
Attributes[WordLength]={Listable};
Options[WordLength]={Overlap->True};
AllOptions[WordLength]={};


WordLength[_?EpsQ] = 0;
WordLength[x_String]:=StringLength[x];
WordLength[_?EpsQ,_,opts:OptionsPattern[]] = 0;
WordLength[x_String,a_String,opts:OptionsPattern[]] := Length[StringPosition[x,a,opts]];


(* ::Subsection::Closed:: *)
(*Words*)


PackageSymbol[Words,
"Words[r,K]  produces a list of words of length r over alphabet K."];


SyntaxInformation[Words] = {"ArgumentsPattern"->{_,_.,OptionsPattern[]}};
Options[Words]={Full->True};
AllOptions[Words]={};


Words[ 0, K_Alpha:$alphabet, opts:OptionsPattern[] ] := {"Eps"};
Words[ {0}, K_Alpha:$alphabet, opts:OptionsPattern[] ] := {"Eps"};
Words[ {r_Integer?Positive}, K_Alpha:$alphabet,opts:OptionsPattern[]  ] := 
    With[ { alph = AlphabetList[K] },
           Apply[ StringJoin, CartesianProduct@@Table[alph,{r}], 1 ]
      ];
Words[  r_Integer?Positive, K_Alpha:$alphabet,opts:OptionsPattern[]  ] := 
    With[ {res = Flatten[ Words[{#},K]& /@ Range[r] ]},
        If[ OptionValue[Full], Prepend[  res, "Eps" ], res ] ];


(* ::Subsection::Closed:: *)
(*ToWord*)


(* ::Text:: *)
(*list must have depth at most 4*)
(*2:	single word*)
(*3:	language*)
(*4:	list of languages*)


PackageSymbol[ToWord,
"ToWord[w,A] converts index list w into a printable word over alphabet A."];


SyntaxInformation[ToWord] = {"ArgumentsPattern"->{_,_.,OptionsPattern[]}};
Options[ToWord]={Full->False};
AllOptions[ToWord]={};


ToWord[{}, A_Alpha:$alphabet ] = "Eps";
ToWord[{xx__Integer}, A_Alpha:$alphabet ] := 
	With[ {AL = Prepend[AlphabetList[A],""]},  StringJoin@@(AL[[#+1]]&/@ {xx}) ];
ToWord[W:{_List...}, A_Alpha:$alphabet ] := 
	With[ {AL = Prepend[AlphabetList[A],""]},  
		Map[ Function[ x, If[x==={},"Eps", StringJoin@@(AL[[#+1]]&/@ x) ]],  W , 
			{If[Depth[W]<4, -2, 2 ]} ] ];


(* ::Subsection::Closed:: *)
(*ToIndex*)


(* ::Text:: *)
(*Note: list version does not deal with Eps.*)


PackageSymbol[ToIndex,
"ToIndex[w,A] converts word w over alphabet A into an index list."];


SyntaxInformation[ToIndex] = {"ArgumentsPattern"->{_,_.,OptionsPattern[]}};
Options[ToIndex]={};
AllOptions[ToIndex]={};


ToIndex[ Eps|"Eps"|Global`\[Epsilon], ___ ] = {};

ToIndex[ x_String, K_Alpha:$alphabet ] := 
With[ {t = AlphabetTrackCount[K], chc = ToCharacterCode[x],
        as = Association[Thread[AlphabetList[K]->Range[AlphabetCount[K]] ]]},
        as /@ StringJoin@@@Map[FromCharacterCode,Partition[chc,t],{2}]
];

ToIndex[ L_List, K_Alpha:$alphabet  ] :=
With[ {t = AlphabetTrackCount[K], as = Association[Thread[AlphabetList[K]->Range[AlphabetCount[K]] ]]},
        Map[ as /@ StringJoin@@@Map[FromCharacterCode,Partition[ToCharacterCode[#],t],{2}]&,L,{-1}]
];


(* ::Subsection::Closed:: *)
(*Randomword*)


(* ::Text:: *)
(*NOTE:  RandomWord is reserved.*)


PackageSymbol[Randomword,
"RandomWord[k,A] generates a random word of length at most k over alphabet A."];


SyntaxInformation[Randomword] = {"ArgumentsPattern"->{_,_.,_.,OptionsPattern[]}};
Options[Randomword]={};
AllOptions[Randomword]={};


Randomword[ {k_Integer?NonNegative}, A_Alpha:$alphabet ] := 
    StringJoin@@RandomChoice[AlphabetList[A],k];

Randomword[ k_Integer?NonNegative, A_Alpha:$alphabet ] := 
    StringJoin@@RandomChoice[AlphabetList[A], RandomInteger[{0,k}]];

Randomword[ {k_Integer?NonNegative}, n_Integer?Positive, A_Alpha:$alphabet ] := 
    Table[ StringJoin@@RandomChoice[AlphabetList[A],k], {n} ];

Randomword[ k_Integer?NonNegative, n_Integer?Positive, A_Alpha:$alphabet ] := 
    Table[ StringJoin@@RandomChoice[AlphabetList[A],RandomInteger[{0,k}]], {n} ];


(* ::Subsection::Closed:: *)
(*WordBinomial*)


PackageSymbol[WordBinomial,
"WordBinomial[u,v,opts] determines the word binomial of u and v."];


SyntaxInformation[WordBinomial] = {"ArgumentsPattern"->{_,_,OptionsPattern[]}};
Options[WordBinomial]={DoTrace->False};
AllOptions[WordBinomial]={DoTrace->{False,True}};

WordBinomial[ v_?WordQ, Eps|""|Global`\[Epsilon] ] := 1;
WordBinomial[ Eps|""|Global`\[Epsilon], u_?WordQ ] := 0;
WordBinomial[ v_?WordQ, u_?WordQ, opts:OptionsPattern[] ] := 
Module[ {vc,vn,uc,un,h},
    vc = If[ Head[v]===List,v,ToCharacterCode[v] ];
    vn = Length[vc];
    uc = If[ Head[u]===List,u,ToCharacterCode[u] ];
    un = Length[uc];
    h[_, 0] := 1;
    h[0, _] := 0;
    h[ i_, j_ ] := h[i, j] = 
		If[ vc[[i]]==uc[[j]], h[i-1, j] + h[i-1, j-1], h[i-1, j] ];
    If[ OptionValue[DoTrace],
		Table[ h[j,i], {i,un}, {j,vn} ],
		h[vn,un] 
	]
];


(* ::Subsection::Closed:: *)
(*WordOrder*)


PackageSymbol[WordOrder,
"WordOrder[u,v] returns a trit indicating the order of words u and v."];


SyntaxInformation[WordOrder] = {"ArgumentsPattern"->{_,_,OptionsPattern[]}};
Options[WordOrder]={};
AllOptions[WordOrder]={};

WordOrder[ x_?WordQ, y_?WordQ ] := 
If[ x===y, 0 ,
	If[WordLength[x]<WordLength[y] ||
		   WordLength[x]==WordLength[y] && Order[x,y]==1, 1 , -1 ] ];


(* ::Subsection::Closed:: *)
(*WordSort*)


PackageSymbol[WordSort,
"WordSort[L] sorts a list of words L in length-lex order."];


SyntaxInformation[WordSort] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[WordSort]={};
AllOptions[WordSort]={};

WordSort[ L_List ] := Sort[ L, WordOrder[#1,#2]>=0& ];


(* ::Subsection::Closed:: *)
(*WordShuffle*)


PackageSymbol[WordShuffle,
"WordShuffle[u,v] generates the shuffle of words u and v."];


SyntaxInformation[WordShuffle] = {"ArgumentsPattern"->{_,_,OptionsPattern[]}};
Options[WordShuffle]={};
AllOptions[WordShuffle]={};

WordShuffle[ e_?EpsQ, v_?WordQ ] := {v};
WordShuffle[ u_?WordQ, e_?EpsQ ] := {u};
WordShuffle[ u_?WordQ, v_?WordQ ] := 
     Apply[ StringJoin, auxShuffle[ToCharacters[u],ToCharacters[v]], 1 ];
WordShuffle[ u_?WordQ, L_List  ] := WordShuffle[ {u}, L ];
WordShuffle[ L_List, u_?WordQ  ] := WordShuffle[ L,{u} ];
WordShuffle[ L1_List, L2_List ] := 
    Union[Flatten[ Apply[ WordShuffle, CartesianProduct[L1,L2], 1 ]]];
     
auxShuffle[{},L_] := {L};
auxShuffle[L_,{}] := {L};
auxShuffle[L1_List,L2_List] := 
    Union[  Prepend[#,First[L1]]& /@ auxShuffle[Rest[L1],L2],
     Prepend[#,First[L2]]& /@ auxShuffle[L1,Rest[L2]]
];
ToCharacters[e_?EpsQ]   := {""};
ToCharacters[w_String] := Characters[w];


(* ::Section::Closed:: *)
(*TransitionSystem*)


(* ::Subsection::Closed:: *)
(*TSys*)


(* ::Text:: *)
(*kill Normalized*)


PackageSymbol[TSys,
"TSys[n,k,t,tr,K,opts] represents a transition system over alphabet K."];


SyntaxInformation[TSys] = {"ArgumentsPattern"->{_,_,_,_,_,OptionsPattern[]}};
Options[TSys]={Normalized->True,States->Automatic,Type->None};
AllOptions[TSys]={Normalized->{True,False,StatesNorm,AlphabetNorm},
	States->{Automatic,_List}};


(* ::Subsection::Closed:: *)
(*TransitionSource*)


PackageSymbol[TransitionSource,
"TransitionSource[t] returns the source of transistion t."];


SyntaxInformation[TransitionSource] = {"ArgumentsPattern"->{_}};
Options[TransitionSource]={};
AllOptions[TransitionSource]={};

TransitionSource[{p_Integer,_,_}] := p;


(* ::Subsection::Closed:: *)
(*TransitionLabel*)


PackageSymbol[TransitionLabel,
"TransitionLabel[t] returns the Label of transistion t."];


SyntaxInformation[TransitionLabel] = {"ArgumentsPattern"->{_}};
Options[TransitionLabel]={};
AllOptions[TransitionLabel]={};

TransitionLabel[{_,s_Integer,_}] := s;


(* ::Subsection::Closed:: *)
(*TransitionTarget*)


PackageSymbol[TransitionTarget,
"TransitionTarget[t] returns the Target of transistion t."];


SyntaxInformation[TransitionTarget] = {"ArgumentsPattern"->{_}};
Options[TransitionTarget]={};
AllOptions[TransitionTarget]={};

TransitionTarget[{_,_,q_Integer}] := q;


(* ::Subsection::Closed:: *)
(*TransitionCount*)


(* ::Text:: *)
(*should probably do a consistency check*)


PackageSymbol[TransitionCount,
"TransitionCount[T] returns the number of transitions of a transition system T."];


SyntaxInformation[TransitionCount] = {"ArgumentsPattern"->{_}};
Attributes[TransitionCount]={Listable};
TransitionCount[T_TSys] := T[[3]];               (* critical *) 
TransitionCount[M_?FSMQ] := TransitionCount[TransitionSystem[M]];     


(* ::Input:: *)
(*TransitionCount[ TSys[ 5, 2,1,{{1,2,3}}, Alpha[2], States->Automatic ] ]*)


(* ::Subsection::Closed:: *)
(*TransitionsRaw*)


(* ::Text:: *)
(*accessor*)


PackageSymbol[TransitionsRaw,
"TransitionsRaw[T] returns the transistions of a transition system T unmodified."];


SyntaxInformation[TransitionsRaw] = {"ArgumentsPattern"->{_}};
Attributes[TransitionsRaw]={Listable};
Options[TransitionsRaw]={};
AllOptions[TransitionsRaw]={};

TransitionsRaw[T_TSys] := T[[4]];            (* critical *) 
TransitionsRaw[M_?FSMQ] := TransitionsRaw[TransitionSystem[M]];    


(* ::Subsection::Closed:: *)
(*TransitionList*)


(* ::Text:: *)
(*Normal clumsy, add type SparseArray*)


PackageSymbol[TransitionList,
"TransitionList[T] returns the transistions of a transition system T."];


SyntaxInformation[TransitionList] = {"ArgumentsPattern"->{_}};
Attributes[TransitionList]={Listable};
Options[TransitionList]={};
AllOptions[TransitionList]={};

TransitionList[T_TSys] := 
With[ {tr = TransitionsRaw[T]}, 
	If[ GetOptionValue[T,Type]===Matrix, 
		DeleteCases[FlattenOne@MapIndexed[ auxToTrans[StateCount[T]], Normal[tr] ], {__,0}],
		tr
	]
];

TransitionList[M_?FSMQ] := TransitionList[TransitionSystem[M]];    

auxToTrans[nn_Integer][ row_List, {s_}] := 
	Pairs[ Range[nn], Table[s,{nn}], row ];


(* ::Subsection::Closed:: *)
(*StateCount*)


PackageSymbol[StateCount,
"StateCount[T] returns the number of states of a transition system T."];


SyntaxInformation[StateCount] = {"ArgumentsPattern"->{_}};
Attributes[StateCount]={Listable};
StateCount[A_TSys] := A[[1]];            (* critical *) 
StateCount[M_?FSMQ] := StateCount[M[[1]]];          (* critical *)


(* ::Subsection::Closed:: *)
(*StateList*)


PackageSymbol[StateList,
"StateList[T] returns the list of states of a transition system T."];


SyntaxInformation[StateList] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[StateList] = {Full->True};
Attributes[StateList]={Listable};
StateList[T_TSys, opts:OptionsPattern[] ] := 
(
  If[ !OptionValue[Full], Return[Range[StateCount[T]] ] ];
  With[ {Q = (States /.  Cases[ T, _Rule, Infinity ])},
	If[ Q === States, Range[StateCount[T]], Q ] ]
);
StateList[M_?FSMQ, opts:OptionsPattern[] ] := StateList[ TransitionSystem[M], opts ];


(* ::Subsection::Closed:: *)
(*SetTransitionSystem*)


PackageSymbol[SetTransitionSystem,
"SetTransitionSystem[M,T] sets the transition system of automaton M to T."];


SyntaxInformation[SetTransitionSystem] = {"ArgumentsPattern"->{_,_,OptionsPattern[]}};
Options[SetTransitionSystem]={};
SetAttributes[SetTransitionSystem,HoldFirst]
SetTransitionSystem[ M_, T_TSys, opts:OptionsPattern[] ] := 
	M = ReplacePart[ M, 1->T ];


(* ::Subsection::Closed:: *)
(*SetStates*)


PackageSymbol[SetStates,
"SetStates[T,Q] sets the states of a transition system T to Q."];


SyntaxInformation[SetStates] = {"ArgumentsPattern"->{_,_,OptionsPattern[]}};
Options[SetStates]={};
SetAttributes[SetStates,HoldFirst];

SetStates::badlen = "New state list has wrong length, needs `1`.";

SetStates[ T_, sts_List, opts:OptionsPattern[] ] := 
If[ ReleaseHold[Head[T] === TSys],
    If[ Length[sts] != StateCount[T], 
        Message[SetStates::badlen, StateCount[T] ];
        Return[T] 
    ];
    T = ReplaceOption[T,States->sts],
	internalSetStates[T,sts]
];

SetStates[ T_, None, opts:OptionsPattern[] ] := 
If[ ReleaseHold[Head[T] === TSys],
    With[ {pos = Position[T,States->_]},
           If[ pos==={},
               T,
               T = Delete[ T, pos[[1,1]] ] 
           ]],
	internalSetStates[T,sts]
];


SetAttributes[internalSetStates,HoldFirst];
internalSetStates[ M_, sts_List ] := 
    Module[ {T = TransitionSystem[M]},
        SetStates[ T, sts ];
	    SetTransitionSystem[ M, T ]
];
SetAttributes[internalSetStates,HoldFirst];
internalSetStates[ M_, None ] := 
    Module[ {T = TransitionSystem[M]},
        SetStates[ T, None ];
	    SetTransitionSystem[ M, T ]
];


(* ::Subsection::Closed:: *)
(*SetAlphabet*)


PackageSymbol[SetAlphabet,
"SetAlphabet[T,A] sets the alphabet of a transition system T to A."];


SetAlphabet::alsze = "Mismatch in alphabet size.";
SyntaxInformation[SetAlphabet] = {"ArgumentsPattern"->{_,_,OptionsPattern[]}};
Options[SetAlphabet]={};
SetAttributes[SetAlphabet,HoldFirst]
SetAlphabet[ T_, alph_, opts:OptionsPattern[] ] := 
If[  AlphabetCount[T]==AlphabetCount[alph],
	T = ReplacePart[T,5->alph ],
	Message[SetAlphabet::alsze]; 
	$Failed
];


(* ::Subsection::Closed:: *)
(*StateDelete*)


(* ::Text:: *)
(*convert DFA to PDFA*)


PackageSymbol[StateDelete,
"StateDelete[T,p,opts] removes state p from a transition system T."];


SyntaxInformation[StateDelete] = {"ArgumentsPattern"->{_,_,OptionsPattern[]}};
Options[StateDelete] = {Full->False};

StateDelete[ T_TSys, p_Integer?Positive, opts:OptionsPattern[] ] :=
		StateDelete[ T, {p}, opts ];
StateDelete[ T_TSys, P:{__Integer?Positive}, opts:OptionsPattern[] ] :=
Module[ {tr,nn,rk,res},
	Assert[ SubsetQ[ Range[StateCount[T]],P ] ];
	tr = Sort@Select[ TransitionList[T],!(MemberQ[P,First[#]] || MemberQ[P,Last[#]])& ];
	nn = StateCount[T]-Length[P];
	AssignFunction[ rk, Complement[Range[StateCount[T]],P], Range[nn] ];
	tr = MapTransitions[ tr, rk ];
	res = TSys[ nn, AlphabetCount[T], Length[tr], tr, GetAlphabet[T] ];
	If[ OptionValue[Full],
		{res,nn,rk},
		res
	]
];

StateDelete[ A_FA|A_TD, P:{__Integer?Positive}, opts:OptionsPattern[] ] :=
Module[ {tr,nn,rk},
	{tr,nn,rk} = StateDelete[ TransitionSystem[A], P, Full->True ];
	Head[A][ tr, rk /@ Complement[InitialStateList[A],P],
		 rk /@ Complement[FinalStateList[A],P] ]
];
StateDelete[  A_FA|A_TD, p_Integer?Positive, opts:OptionsPattern[] ] :=
	StateDelete[ A, {p}, opts ];

(*  should sparsify *)
StateDelete[  A_DFA, P:{__Integer?Positive}, opts:OptionsPattern[] ] :=
	StateDelete[  ToFA[A], P, opts ];
StateDelete[  A_DFA, p_Integer?Positive, opts:OptionsPattern[] ] :=
	StateDelete[ A, {p}, opts ];


(* ::Subsection::Closed:: *)
(*EpsilonFreeQ*)


PackageSymbol[EpsilonFreeQ,
"EpsilonFreeQ[T] checks whether transition system T is epsilon-free."];


SyntaxInformation[EpsilonFreeQ] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[EpsilonFreeQ]={};

EpsilonFreeQ[ M_FA ] := EpsilonFreeQ[M[[1]]];    (*  critical  *)
EpsilonFreeQ[ M_DFA ] := True; 
EpsilonFreeQ[ ts_TSys ] := Cases[TransitionList[ts], {_,0,_} ]==={};


(* ::Subsection::Closed:: *)
(*FullProductTransitions*)


(* ::Text:: *)
(*Probably should be private.*)
(**)
(*SLOW*)


PackageSymbol[FullProductTransitions,
"FullProductTransitions[T1,T2] generates the product of transition lists T1 and T2."];


SyntaxInformation[FullProductTransitions] = {"ArgumentsPattern"->{_,_,_,OptionsPattern[]}};
Options[FullProductTransitions]={Full->Automatic,Normalize:>Automatic};
AllOptions[FullProductTransitions]={Full->{Automatic,Sorted,Strict}};


auxProductTrans[{{p_,s_,q_},{pp_,s_,qq_}}] := {{p,pp},s,{q,qq}};
auxSortTrans[ {p_,s_,q_} ] := { Sort[p], s, Sort[q] };


FullProductTransitions[ L1_List, L2_List, k_Integer, opts:OptionsPattern[] ] := 
Module[ {TT},  
	TT = FlattenOne@Table[ 
	auxProductTrans /@ CartesianProduct[ Cases[L1,{_,s,_}], Cases[L2,{_,s,_}] ], 
		{s,0,k} ];
	Switch[ OptionValue[Full],
			Automatic,  TT,
			Sorted,	 Union[ auxSortTrans /@ TT ],
			Strict,	 DeleteCases[ Union[ auxSortTrans /@ TT ], {{p_,p_},_,_} | {_,_,{q_,q_}} ]
		]
];


(* ::Subsection::Closed:: *)
(*ProductTransitionSystem*)


PackageSymbol[ProductTransitionSystem,
"ProductTransitionSystem[T1,T2] generates the product of transition systems T1 and T2."];


SyntaxInformation[ProductTransitionSystem] = {"ArgumentsPattern"->{_,_,_.,OptionsPattern[]}};
Options[ProductTransitionSystem]={Normalize:>Automatic};
AllOptions[ProductTransitionSystem]={};


ProductTransitionSystem[ M1_TSys, M2_TSys, init_List:{}, opts:OptionsPattern[] ] := 
Module[ {k,Tr0,T1,T2,tt,A,n,n1,n2,Q,Q1,Q2,res,ff,gg,fg,r1,r2},
     k = AlphabetCount[M1];
Assert[ AlphabetCount[M2] == k ];
     n1  = StateCount[ M1 ];
     n2  = StateCount[ M2 ];
     If[ EpsilonFreeQ[M2], 
         T1 = TransitionList[M1], 
         T1 = Join[TransitionList[M1], Pairs[Range[n1],Table[0,{n1}],Range[n1]]]
     ];
     If[ EpsilonFreeQ[M1], 
         T2 = TransitionList[M2], 
         T2 = Join[TransitionList[M2], Pairs[Range[n2],Table[0,{n2}],Range[n2]]]
     ];

	If[  init==={},  
(* full Cartesian product *)
		tt = DeleteCases[FullProductTransitions[ T1, T2, k, opts ], {x_,0,x_} ];     
		Q = Union[ First/@ tt, Last/@ tt ];
		AssignFunction[ ff, Q, Range[Length[Q]] ];
		tt =  MapTransitions[ tt, ff ];
(*  reachable part only *) ,
		ff = SymbolList["fproducttrans",k];
		gg = SymbolList["gproducttrans",k];
		TransitionFunctionList[ ff, M1 ];
		TransitionFunctionList[ gg, M2 ];
		fg[s_][{p_,q_}] := CartesianProduct[ff[[s]][p],gg[[s]][q]];
		{Q,tt} = Closure[ init, fg /@ Range[k], 
                  Cayley->True, SetClosure->True, InitialSet->True ]
	];
	n = Length[Q];
    res = TSys[ n, k, Length[tt], tt, GetAlphabet[M1] ];
	Switch[ OptionValue[Normalize], 
		Full, res,
		Automatic, SetStates[ res, Q ],
		None,
			AssignFunction[ r1, Range[n1], StateList[M1]];
			AssignFunction[ r2, Range[n2], StateList[M2]];
			SetStates[ res, 
			MapAt[ r2, MapAt[r1,Q,CartesianProduct[Range[n],{1}] ], CartesianProduct[Range[n],{2}]]]
		]
];


(* ::Subsection::Closed:: *)
(*MapTransitions*)


PackageSymbol[MapTransitions,
"MapTransitions[tr,f,g] applies functions f and g to states and symbols in transition list tr."];


SyntaxInformation[MapTransitions] = {"ArgumentsPattern"->{_,_,_.,OptionsPattern[]}};
Options[MapTransitions]={};

MapTransitions[ tr_List, fst_, fsym_:Identity ] := 
With[ {n = Length[tr]}, 
	Thread@MapAt[ fsym, MapAt[ fst, Thread[tr], Join[CartesianProduct[{1,3},Range[n]]] ],
		CartesianProduct[{2},Range[n]]] ];


(* ::Subsection::Closed:: *)
(*TransitionFunctionList*)


(* ::Text:: *)
(*curried transition function, should be option Curried->True in AssignTransitionFunction*)
(*Type->DFA    Q \[Cross] \[CapitalSigma] \[LongRightArrow] Q,   otherwise      Q \[Cross] \[CapitalSigma] \[LongRightArrow]\[GothicCapitalP](Q)*)
(*either case lift       \[GothicCapitalP](Q) \[Cross] \[CapitalSigma] \[LongRightArrow]\[GothicCapitalP](Q)*)


PackageSymbol[TransitionFunctionList,
"TransitionFunctionList[ff,T] assigns to symbol list ff the curried transition functions of transitions system T."];


SyntaxInformation[TransitionFunctionList] = {"ArgumentsPattern"->{_,_,_.,OptionsPattern[]}};
Options[TransitionFunctionList]={DFA->False};

fixClassFirst[L_List] := {L[[1,1]], Last/@L};

TransitionFunctionList[ hhh_List, M_?FSMQ, opts:OptionsPattern[]] := 
	TransitionFunctionList[ hhh,  TransitionSystem[M], opts ];

TransitionFunctionList[ hhh_List, T_TSys, opts:OptionsPattern[]] := 
	TransitionFunctionList[ hhh, StateCount[T], AlphabetCount[T], TransitionList[T], opts ];

TransitionFunctionList[ hhh_List, n_Integer, k_Integer, tr_List, opts:OptionsPattern[ ]] := 
Module[ {tri,cls,XXXX},
	Do[ 
		tri = Drop[#,{2}]& /@ Cases[tr,{_,i,_}];
		cls = fixClassFirst /@ GatherBy[ tri, First ];
        If[ OptionValue[DFA], cls = Flatten/@cls ];
		AssignFunction[ Release[hhh[[i]]], cls ];
		Release[hhh[[i]]][_Integer] := {};
        If[ OptionValue[DFA], 
    		AppendTo[ DownValues[Release[hhh[[i]]]], 
	    		HoldPattern[XXXX[L_List]] :> Union[ XXXX /@ L ] /. XXXX->hhh[[i]]] ,
        (* else non-det *)
    		AppendTo[ DownValues[Release[hhh[[i]]]], 
	    		HoldPattern[XXXX[L_List]] :> Union@@( XXXX /@ L ) /. XXXX->hhh[[i]]] 
        ]
		,
		{i,k}
	];
	hhh
]  /;  Length[hhh]==k;


(* ::Subsection::Closed:: *)
(*AssignTransitionFunction*)


(* ::Text:: *)
(*see TransitionFunctionList*)
(*does not check for DFA, feature?*)


PackageSymbol[AssignTransitionFunction,
"AssignTransitionFunction[del,T] assigns to symbol del the transition function of transition system T.
Use option Full->True to deal with sets of states."];


SyntaxInformation[AssignTransitionFunction] = {"ArgumentsPattern"->{_,_,_.,_.,OptionsPattern[]}};
SetAttributes[AssignTransitionFunction,HoldFirst]
Options[AssignTransitionFunction]={DFA->False};

AssignTransitionFunction[ del_, M_?FSMQ, opts:OptionsPattern[] ] := 
	AssignTransitionFunction[ del,  StateCount[M], AlphabetCount[M], TransitionList[M], opts ];

AssignTransitionFunction[ del_, T_TSys, opts:OptionsPattern[] ] := 
	AssignTransitionFunction[ del, StateCount[T], AlphabetCount[T], TransitionList[T], opts ];

AssignTransitionFunction[ del_, n_Integer, k_Integer, tr_List, opts:OptionsPattern[]] := 
Module[ {auxhhh},
	auxhhh = Unique[ Table[ StringJoin[ "auxh", StringPadLeft[ ToString[i],6,"0"]], {i,k}]];
	TransitionFunctionList[ auxhhh, n, k, tr, opts ];
    	del[p_, s_Integer] := del[p,{s}];   (*auxhhh[[s]][p];*)
	    del[p_, {} ] := p;
	    del[p_, w_List ]:= Fold[ auxhhh[[#2]][#1]&, p, w ];
];


(* ::Subsection::Closed:: *)
(*TransitionMatrix*)


(* ::Text:: *)
(*Returns  k \[Cross] n  array of lists of integers.*)
(*Add SparseArray for DFA with sink (or non-trim DFA in general). *)


PackageSymbol[TransitionMatrix,
"TransitionMatrix[T] constucts the transition matrix of transition system T."];


SyntaxInformation[TransitionMatrix] = {"ArgumentsPattern"->{_,_.,_.,OptionsPattern[]}};
Options[TransitionMatrix]={Type->"Basic",Full->True};
AllOptions[TransitionMatrix]={};
TransitionMatrix::badopt ="Option `1` not known for command TransitionMatrix.";



TransitionMatrix[ M_?FSMQ, opts:OptionsPattern[] ] :=  
	TransitionMatrix[ M[[1]], opts ];     (* critical *)

TransitionMatrix[T_TSys, opts:OptionsPattern[] ] :=
Switch[  OptionValue[Type],
	"Basic", basicTransitionMatrixFA[T,SelectOptions[basicTransitionMatrixFA,opts]],
	"Natural", natTransitionMatrixFA[T,SelectOptions[natTransitionMatrixFA,opts]],
	"Boolean",boolTransitionMatrixFA[T,SelectOptions[boolTransitionMatrixFA,opts]],
	_, Message[ TransitionMatrix::badopt, OptionValue[Type] ]
]
 
TransitionMatrix[ n_Integer, k_Integer, tr_List, opts:OptionsPattern[]  ] := 
Module[{tt,rp},
	tt = #[[{2,1,3}]]& /@ tr;
	rp = Reap[ Scan[ Sow[#,{#}]&, Union[Most /@ tt] ];
				Scan[ Sow[Last[#],{Most[#]}]&, tt ]  ][[2]];
	If[ OptionValue[Type]===DFA,
		Return[SparseArray[ Rule@@@rp, {k,n}]] 
	];
	ReplacePart[ Array[ {}&, {k,n}], Rule@@@({First[#],Rest[#]}& /@ rp) ]
];


trToRule[{p_, s_, q_}] := {s, p, q} -> 1;

Options[basicTransitionMatrixFA] = {};
basicTransitionMatrixFA[ T_TSys, opts : OptionsPattern[]  ] :=
If[ GetOptionValue[T,Type]===Matrix , 
	TransitionsRaw[T],
	TransitionMatrix[ StateCount[T], AlphabetCount[T], TransitionList[T], opts ]
];

Options[natTransitionMatrixFA] = {Full -> True};
natTransitionMatrixFA[ T_TSys, opts : OptionsPattern[]  ] :=
  Module[ {k, n, res},
   n = StateCount[T];
   k = AlphabetCount[T];
   res = SparseArray[ trToRule /@ TransitionList[T], {k, n, n}];
   If[ OptionValue[Full], res, Total[res] ]
   ];

Options[boolTransitionMatrixFA] = {Full -> True};
boolTransitionMatrixFA[ T_TSys, opts : OptionsPattern[]  ] :=
  Module[ {k, n, res},
   n = StateCount[T];
   k = AlphabetCount[T];
   res = SparseArray[ trToRule /@ TransitionList[T], {k, n, n}];
   If[ OptionValue[Full], res, Sign[Total[res]] ]
   ];



(* ::Subsection::Closed:: *)
(*TransitionsToSparse*)


(* ::Text:: *)
(*Returns  k \[Cross] n  sparse array of integers*)
(*Useful for partial DFAs *)


PackageSymbol[TransitionsToSparse,
"TransitionsToSparse[T] constucts the sparse transition matrix of transitions system T."];


SyntaxInformation[TransitionsToSparse] = {"ArgumentsPattern"->{_,_.,_.,OptionsPattern[]}};
Options[TransitionsToSparse]={Type-> DFA};
AllOptions[TransitionsToSparse]={};


TransitionsToSparse[ T_TSys, opts:OptionsPattern[]  ] := 
	TransitionsToSparse[ StateCount[T], AlphabetCount[T], TransitionList[T], opts ];
TransitionsToSparse[ n_Integer, k_Integer, tr_List, opts:OptionsPattern[]  ] := 
	SparseArray[ {#[[2]],#[[1]]}->#[[3]]& /@ tr, {k,n} ];


(* ::Subsection::Closed:: *)
(*TransitionToBooleanMatrix*)


(* ::Text:: *)
(*Returns  k \[Cross] n \[Cross] n  sparse array of booleans (0/1, actually) or naturals*)


PackageSymbol[TransitionToBooleanMatrix,
"TransitionToBooleanMatrix[T] constucts the Boolean transition matrix of transitions system T."];


SyntaxInformation[TransitionToBooleanMatrix] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[TransitionToBooleanMatrix]={Type->None};


auxTranToRule[{{p_,s_,q_},c_}] := {s,p,q}->c;
auxTranToRule[{p_,s_,q_}] := {s,p,q}->1;


TransitionToBooleanMatrix[ M_?FSMQ, opts:OptionsPattern[] ] :=
	TransitionToBooleanMatrix[ TransitionSystem[M] ];
TransitionToBooleanMatrix[ T_TSys, opts:OptionsPattern[] ] :=
With[ {n = StateCount[T],k = AlphabetCount[T]},
	Switch[ OptionValue[Type],
		None,       SparseArray[ auxTranToRule /@ Tally[TransitionList[T]], {k,n,n} ],
		Boolean,    SparseArray[ auxTranToRule /@ TransitionList[T], {k,n,n} ]
]];


(* ::Subsection::Closed:: *)
(*SubTransitionSystem*)


(* ::Text:: *)
(*Vertex induced, only normalized*)


PackageSymbol[SubTransitionSystem,
"SubTransitionSystem[T,P] constucts the sub-transitions system of T induced by P."];


SyntaxInformation[SubTransitionSystem] = {"ArgumentsPattern"->{_,_,OptionsPattern[]}};
Options[SubTransitionSystem]={};
AllOptions[SubTransitionSystem]={};


Options[SubTransitionSystem]={Full->True};
SubTransitionSystem[ T_TSys, V_List, opts:OptionsPattern[] ] := 
Module[ {tr,Q,rk}, 
	tr = Select[ TransitionList[T], MemberQ[V,#[[1]]] && MemberQ[V,#[[-1]]]& ];
	Q = Union[First/@tr,Last/@tr];
	AssignFunction[ rk, Q, Range[Length[Q]] ];
	If[ OptionValue[Full],
	TSys[ Length[Q], AlphabetCount[T], Length[tr], MapTransitions[tr,rk], 
		GetAlphabet[T], States->Q ],
	TSys[ Length[Q], AlphabetCount[T], Length[tr], MapTransitions[tr,rk], 
		GetAlphabet[T] ] 
	]	
];


(* ::Subsection::Closed:: *)
(*ReverseTransitions*)


(* ::Text:: *)
(*Vertex induced, only normalized*)


PackageSymbol[ReverseTransitions,
"ReverseTransitions[T] constucts the reversal of the transitions system T."];


SyntaxInformation[ReverseTransitions] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[ReverseTransitions]={};
AllOptions[ReverseTransitions]={};


ReverseTransitions[ T_TSys, opts:OptionsPattern[] ] := 
	ReplacePart[ T, 4 -> Reverse /@ TransitionList[T] ];


(* ::Section::Closed:: *)
(*Finite Automata*)


(* ::Subsection::Closed:: *)
(*FSMQ*)


PackageSymbol[FSMQ,
"FSMQ[M] checks whether M is a finite state machine (Head comparison only)."];


SyntaxInformation[FSMQ] = {"ArgumentsPattern"->{__, OptionsPattern[]}};
SetAttributes[FSMQ,Listable];
Options[FSMQ] = {};
AllOptions[FSMQ]={};

FSMQ[m_] :=  MemberQ[{FA,DFA,TD},Head[m]];


(* ::Subsection::Closed:: *)
(*AccCond*)


(* ::Text:: *)
(*just a stub*)


PackageSymbol[AccCond,
"AccCond[args] represents the acceptance condition of an automaton A."];


SyntaxInformation[AccCond] = {"ArgumentsPattern"->{__, OptionsPattern[]}};
Options[AccCond] = {Type->Existential};
AllOptions[AccCond]={Type->{Existential,Universal,Alternating,Buechi,Rabin,Muller}};

(*  AccCond[ q0, F ]   *) 


(* ::Subsection::Closed:: *)
(*Automaton*)


(* ::Text:: *)
(*Reduce number of types*)
(*FA		eps, no-eps, semi,  transition list; Buechi, Rabin, Muller*)
(*DFA		total/partial, transition matrix (sparse)*)
(*TD                     invertible              *)


PackageSymbol[FA,
"FA[args] represents a non-deterministic automaton."];


SyntaxInformation[FA] = {"ArgumentsPattern"->{_,_,_, OptionsPattern[]}};
Options[FA] = {Props->{}};
AllOptions[FA]={Props->{{},"Minimal","Unambiguous"}};

(*  Automaton[ TSys[...], acceptance, opts ]   *) 


PackageSymbol[DFA,
"DFA[args] represents a deterministic complete automaton."];


SyntaxInformation[DFA] = {"ArgumentsPattern"->{_,_,_, OptionsPattern[]}};
Options[DFA] = {Props->{}};
AllOptions[DFA]={Props->{{},"Minimal","Unambiguous"}};

(*  Automaton[ TSys[...], acceptance, opts ]   *) 


PackageSymbol[TD,
"TD[args] represents a transducer."];


$defaultnormalize = Full;


(* ::Subsection::Closed:: *)
(*TransitionSystem*)


PackageSymbol[TransitionSystem,
"TransitionSystem[A] returns the transition system of an automaton A."];


SyntaxInformation[TransitionSystem] = {"ArgumentsPattern"->{_}};
Attributes[TransitionSystem]={Listable};
TransitionSystem[M_?FSMQ] := M[[1]];     (* critical  *)


(* ::Subsection::Closed:: *)
(*InitialStateList*)


PackageSymbol[InitialStateList,
"InitialStateList[T] returns the list of states of a transition system T (normalized)."];


SyntaxInformation[InitialStateList] = {"ArgumentsPattern"->{_}};
Attributes[InitialStateList]={Listable};
InitialStateList[M_?FSMQ] :=    (* critical  *)
With[ {ini = M[[2]]}, 
	If[ ini === All, Range[StateCount[M]], Flatten[{ini}] ] ];
InitialStateList[L_List] := L;


(* ::Subsection::Closed:: *)
(*InitialState*)


PackageSymbol[InitialState,
"InitialState[M] returns the initial state of a DFA M (normalized)."];


SyntaxInformation[InitialState] = {"ArgumentsPattern"->{_}};
Attributes[InitialState]={Listable};
InitialState[M_DFA] := M[[2]];   (* critical  *)


(* ::Subsection::Closed:: *)
(*FinalStateList*)


PackageSymbol[FinalStateList,
"StateList[T] returns the list of states of a transition system T (normalized)."];


SyntaxInformation[FinalStateList] = {"ArgumentsPattern"->{_}};
Attributes[FinalStateList]={Listable};
FinalStateList[M_?FSMQ] :=    (* critical  *)
With[ {fin = M[[3]]}, 
	If[ fin === All, Range[StateCount[M]], fin ] ];
FinalStateList[L_List] := L;


(* ::Subsection::Closed:: *)
(*TrapStateList*)


PackageSymbol[TrapStateList,
"TrapStateList[M] returns the list of trap states of automaton M."];


SyntaxInformation[TrapStateList] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[TrapStateList]={Full->True};


TrapStateList[ M_?FSMQ, opts:OptionsPattern[] ] :=    
Module[ {trp},
	trp = TrapStateList[TransitionSystem[M]];
	If[ OptionValue[Full],
		trp,
		Complement[trp,FinalStateList[M]]
	]
];

TrapStateList[ T_TSys, opts:OptionsPattern[] ] :=    
Module[ {A,k,n},
	n = StateCount[T];
	k = AlphabetCount[T];
	A = Thread[TransitionMatrix[n,k,TransitionList[T]]];
	Pick[ Range[n], MapIndexed[ SameQ, Union/@ Flatten/@ A ] ]
];


(* ::Subsection::Closed:: *)
(*TypeFSM*)


(* ::Text:: *)
(*FIX FIX FIX*)


PackageSymbol[TypeFSM,
"TypeFSM[A] returns the type of automaton A."];


SyntaxInformation[TypeFSM] = {"ArgumentsPattern"->{_}};
Attributes[TypeFSM]={Listable};


TypeFSM[m_?FSMQ] := With[ {tr = Transitions[m]},
	If[ MatrixQ[tr] && Dimensions[tr]==={AlphabetCount[m],StateCount[m]},
		Switch[ tr,
			_?MatrixQ,  DFA
                        ]
         ]
];


(* ::Subsection::Closed:: *)
(*TrimStateList*)


(* ::Text:: *)
(*vertices are normalized   V = [n]*)
(*VertexInComponent*)
(*VertexOutComponent*)


PackageSymbol[TrimStateList,
"TrimStateList[M,opts] returns a list of the states in the (accessible, coaccessible, trim) part of automaton M."];


SyntaxInformation[TrimStateList] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[TrimStateList]={Type->Trim};
AllOptions[TrimStateList]={Type->{Trim,Accessible,Coaccessible}};


TrimStateList[ M_?FSMQ, opts:OptionsPattern[] ] :=
With[ {G = TransitionsToGraph[M]},
	Switch[ OptionValue[Type],
		Accessible, VertexOutComponent[G,InitialStateList[M]],
		Coaccessible, VertexInComponent[G,FinalStateList[M]],
		_,  Return[ auxTrimFA[ G, InitialStateList[M], FinalStateList[M] ] ]
	]
];

auxTrimFA[ G_Graph, A_List, B_List ] := 
With[ {AA = VertexOutComponent[G,A]},
		Intersection[AA,VertexInComponent[G,Intersection[AA,B]]] ];


(* ::Subsection::Closed:: *)
(*TrimFA*)


(* ::Text:: *)
(*should update Props*)
(*deal with normalization*)


PackageSymbol[TrimFA,
"TrimFA[M,opts] returns the (accessible, coaccessible, trim) part of automaton A."];


SyntaxInformation[TrimFA] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[TrimFA]={Type->Trim,Normalize:>$defaultnormalize};
AllOptions[TrimFA]={Type->{Trim,Accessible,Coaccessible},Normalize->{None,Automatic,Full}};


TrimFA[ M_FA|M_TD, opts:OptionsPattern[] ] :=
Module[ {QQ,tr,k,nn,rk,res},
	k = AlphabetCount[M];
	QQ = TrimStateList[ M, SelectOptions[TrimStateList,opts] ];
    nn = Length [QQ]; 
	tr = Select[ TransitionList[M], MemberQ[QQ,TransitionSource[#]] && 
						MemberQ[QQ,TransitionTarget[#]]& ]; 
	AssignFunction[ rk, QQ, Range[nn]];
	tr = MapTransitions[ tr, rk ];
	res = Head[M][ TSys[ Length[QQ], k, Length[tr], tr, GetAlphabet[M], States->QQ ],
		rk /@ Intersection[ InitialStateList[M], QQ ],
		rk /@ Intersection[ FinalStateList[M], QQ ]
	]
];

TrimFA[ M_DFA, opts:OptionsPattern[] ] :=
Module[ {QQ,nn,tr,rk,k,ini,fin},
	k = AlphabetCount[M];
	QQ = TrimStateList[ M, SelectOptions[TrimStateList,opts] ];
	nn = Length[QQ];
	ini = Intersection[ InitialStateList[M], QQ ];
	fin = Intersection[ FinalStateList[M], QQ ];
	If[ ini==={} || fin==={}, 
		Return[ ConstructFA[GetAlphabet[M],Type->"Empty" ] ] ];
	tr = Select[ TransitionList[M], MemberQ[QQ,TransitionSource[#]] && 
						MemberQ[QQ,TransitionTarget[#]]& ];  
	AssignFunction[ rk, QQ, Range[nn]];
	tr = MapTransitions[ tr, rk ];
(*debugPrint["trprt trans",QQ," ",tr];*)
	If[ Length[tr]== nn k,
		DFA[ TSys[ nn, k, nn k,
			TransitionsToSparse[Length[QQ],k,tr],  GetAlphabet[M], 
			Type->Matrix, States->QQ ], rk@ini[[1]], rk/@fin ],
		FA[ TSys[ nn, k, Length[tr], tr, GetAlphabet[M], States->QQ ], 
			rk /@ ini, rk /@ fin ]
	]		
];


(* ::Subsection::Closed:: *)
(*ToFA*)


(* ::Text:: *)
(*include BEFA, NNFA ?*)


PackageSymbol[ToFA,
"ToFA[M] converts the automaton M to an FA."];


SyntaxInformation[ToFA] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[ToFA]={Normalize:>$defaultnormalize};
AllOptions[ToFA]={};


ToFA[ M_FA, opts:OptionsPattern[] ] := M;

ToFA[ M_DFA, opts:OptionsPattern[] ] := 
With[ {tr = TransitionList[M]},
     FA[ TSys[ StateCount[M], AlphabetCount[M], Length[tr], tr, GetAlphabet[M] ],
         InitialStateList[M], FinalStateList[M] ] ];


(* ::Subsection::Closed:: *)
(*SetInitialFA*)


(* ::Text:: *)
(*should check for DFA*)


PackageSymbol[SetInitialFA,
"SetInitialFA[M,I] sets the initial states of an automaton M."];


SyntaxInformation[SetInitialFA] = {"ArgumentsPattern"->{_,_.,OptionsPattern[]}};
Options[SetInitialFA]={};
SetAttributes[SetInitialFA,HoldFirst];

SetInitialFA[ M_, ini_List|ini_Integer?Positive|ini:All, opts:OptionsPattern[] ] :=         (* critical *)
(
    If[ Head[M]===FA || IntegerQ[ini],
        Return[ M  = ReplacePart[ M, -2 -> ini ] ] ];
    M = ReplacePart[ ToFA[M], -2 -> ini ]
);


(* ::Subsection::Closed:: *)
(*SetFinalFA*)


(* ::Text:: *)
(*should check for DFA*)


PackageSymbol[SetFinalFA,
"SetFinalFA[M,F] sets the final states of an automaton M."];


SyntaxInformation[SetFinalFA] = {"ArgumentsPattern"->{_,_.,OptionsPattern[]}};
Options[SetFinalFA]={};
SetAttributes[SetFinalFA,HoldFirst];

SetFinalFA[ M_, fin_List|fin:All, opts:OptionsPattern[] ] :=         (* critical *)
    M  = ReplacePart[ M, -1 -> fin ];


(* ::Subsection::Closed:: *)
(*SetInitialFinalFA*)


PackageSymbol[SetInitialFinalFA,
"SetInitialFinalFA[M,I,F] sets the initial and final states of an automaton M."];


SyntaxInformation[SetInitialFinalFA] = {"ArgumentsPattern"->{_,_,_,OptionsPattern[]}};
Options[SetInitialFinalFA]={};
SetAttributes[SetInitialFinalFA,HoldFirst];

SetInitialFinalFA[ M_, ini_List|ini_Integer?Positive|ini:All, fin_List|fin:All, opts:OptionsPattern[] ] := 
    ( SetInitialFA[ M, ini ];  SetFinalFA[ M, fin ] );


(* ::Subsection::Closed:: *)
(*ToAllFA*)


PackageSymbol[ToAllFA,
"ToAllFA[M] replaces sets of initial and final states in M by All where appropriate."];


SyntaxInformation[ToAllFA] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[ToAllFA]={};
SetAttributes[ToAllFA,HoldFirst];

ToAllFA[ M_?FSMQ, opts:OptionsPattern[] ] := 
With[ {n = StateCount[M]},
	If[ Length[InitialStateList[M]]==n, SetInitialFA[M,All] ];
	If[ Length[FinalStateList[M]]==n,  SetFinalFA[M,All]];
	M
];


(* ::Subsection::Closed:: *)
(*SubFA*)


PackageSymbol[SubFA,
"SubFA[M,P] generates the subautomaton induced by state set P."];


SyntaxInformation[SubFA] = {"ArgumentsPattern"->{_,_,OptionsPattern[]}};
Options[SubFA]={};

SubFA[ M_?FSMQ, P_List, opts:OptionsPattern[] ] := 
Module[  {ts,in,fn,rk,fa},
	ts = SubTransitionSystem[TransitionSystem[M],P];
	in = Intersection[ InitialStateList[M], P ];
	fn = Intersection[ FinalStateList[M], P ];
	AssignFunction[ rk, P, Range[Length[P]] ];
	fa = FA[ ts, rk/@in, rk/@fn ];
	ToAllFA[fa]
];


(* ::Subsection::Closed:: *)
(*TransitionAdd*)


PackageSymbol[TransitionAdd,
"TransitionAdd[M,p,s,q] add transition {p,s,q} to automaton M."];


SyntaxInformation[TransitionAdd] = {"ArgumentsPattern"->{_,_,_.,_.,OptionsPattern[]}};
Options[TransitionAdd]={};

TransitionAdd[M_TSys,p_Integer,S:{___Integer?NonNegative},q_Integer]:=Module[{n,nn,k,P,tr,alph,res},
	n=nn=StateCount[M];
	k = AlphabetCount[M];
	Assert[Max[S]<=k ];
	If[p>n,nn++];
	If[q>n,nn++];
	nn+=Length[S]-1;
	P =Partition[Join[{p},Complement[Range[n+1,nn],{p,q}],{q}],2,1];
	tr=Pairs[First/@P,S,Last/@P];
	res=Join[TransitionList[M],tr];
	TSys[ nn, k, Length[res], res, GetAlphabet[M] ]
];
TransitionAdd[ M_TSys, p_Integer, s_Integer?NonNegative, q_Integer ] := TransitionAdd[ M, p, {s}, q ];
TransitionAdd[ M_TSys, {p_Integer, s_, q_Integer} ] := TransitionAdd[ M, p, s, q ];
TransitionAdd[ M_TSys, tr:{___List} ] := Fold[ TransitionAdd,M, tr ];
TransitionAdd[M_FA,args__ ]:=
	Module[ {MM = M},
		SetTransitionSystem[ MM, TransitionAdd[  TransitionSystem[M], args ] ] ];


(* ::Subsection::Closed:: *)
(*TransitionDelete*)


PackageSymbol[TransitionDelete,
"TransitionDelete[M,p,s,q] removes transition {p,s,q} from automaton M."];


SyntaxInformation[TransitionDelete] = {"ArgumentsPattern"->{_,_,_.,_.,OptionsPattern[]}};
Options[TransitionDelete]={Full->False};


TransitionDelete[ T_TSys, tr:{_Integer?Positive,_Integer?Positive,_Integer?Positive}, opts : OptionsPattern[] ] :=
  		TransitionDelete[ T, {tr}, opts ];
TransitionDelete[ T_TSys, P : {{_Integer?Positive,_Integer?Positive,_Integer?Positive}..}, opts : OptionsPattern[] ] :=
  Module[ {tr, nn, rk, res},
Assert[ SubsetQ[ Range[StateCount[T]],Union[First/@P,Last/@P ] ] ];Assert[ SubsetQ[ Range[AlphabetCount[T]],Union[Zwei/@P ] ] ];tr =  Complement[ TransitionList[T], P ];
Q = Union[First/@tr,Last/@tr ];
   	nn = Length[Q];
   	If[ nn < StateCount[T],
		AssignFunction[ rk, Q, Range[nn] ],
		rk = Identity
	];
   	tr = MapTransitions[ tr, rk ];
   	res = TSys[ nn, AlphabetCount[T], Length[tr], tr, GetAlphabet[T] ];
   	If[ OptionValue[Full],
    		{res, nn, rk},
    		res
    	]
   ];

TransitionDelete[ A_FA | A_TD,  P : {{_Integer?Positive,_Integer?Positive,_Integer?Positive}..}, opts : OptionsPattern[] ] :=
  Module[ {tr, nn, rk},
   	{tr, nn, rk} = TransitionDelete[ TransitionSystem[A], P, Full -> True ];
   	Head[A][ tr, rk /@ Complement[InitialStateList[A], P],
    		 rk /@ Complement[FinalStateList[A], P] ]
   ];
TransitionDelete[  A_FA | A_TD,tr:{_Integer?Positive,_Integer?Positive,_Integer?Positive}, opts : OptionsPattern[] ] :=
  	TransitionDelete[ A, {tr}, opts ];

(*  should sparsify *)
TransitionDelete[  A_DFA, P : {{_Integer?Positive,_Integer?Positive,_Integer?Positive}..}, opts : OptionsPattern[] ] :=
  	TransitionDelete[  ToFA[A], P, opts ];
TransitionDelete[  A_DFA,tr:{_Integer?Positive,_Integer?Positive,_Integer?Positive}, opts : OptionsPattern[] ] :=
  	TransitionDelete[ A, {tr}, opts ];


(* ::Section::Closed:: *)
(*Constructors*)


(* ::Subsection::Closed:: *)
(*ConstructFA*)


(* ::Text:: *)
(*Construct assorted FSMs from parameters:*)


PackageSymbol[ConstructFA,
"ConstructFA[agrs,opts] constucts an automaton from parameters args."];


SyntaxInformation[ConstructFA] = {"ArgumentsPattern"->{_.,_.,OptionsPattern[]}};
Options[ConstructFA]={Type->"Empty",Full->False,Normalize:>$defaultnormalize};
AllOptions[ConstructFA]={Type->{"Empty","Universal","Quotient","Factor","Scattered","Prefix","Suffix"}};
ConstructFA::badopt = "Bad option `1` for ConstructFA.";


ConstructFA[] = {"Empty","Universal","Quotient","Factor","Scattered","Prefix","Suffix"};
ConstructFA[ args___, opts:OptionsPattern[] ] :=
Switch[ OptionValue[Type],
		"Empty",  auxEmptyFA[args,SelectOptions[auxEmptyFA,opts]],
		"Universal",  auxUniversalFA[args,SelectOptions[auxUniversalFA,opts]],
		"Quotient", auxQuotientFA[ args, SelectOptions[auxQuotientFA,opts] ],
		"Factor", auxFactorFA[ args, SelectOptions[auxFactorFA,opts] ],
		"Scattered", auxScatteredFA[ args, SelectOptions[auxScatteredFA,opts] ],
		"Prefix", auxPrefixFA[ args, SelectOptions[auxPrefixFA,opts] ],
		"Suffix", auxSuffixFA[ args, SelectOptions[auxSuffixFA,opts] ],
		_, Message[ConstructFA::badopt, ToString@OptionValue[Type] ]
	];

Options[auxEmptyFA]={Full->True};
auxEmptyFA[ K_Alpha:$alphabet, opts:OptionsPattern[] ] := 
With[ {k = AlphabetCount[K]},
	If[ OptionValue[Full],
		DFA[ TSys[ 2, k, 2 k, Table[{1,2},{k}], K, Type->Matrix ],1, {2} ],
		DFA[ TSys[ 1, k, k, Table[{1},{k}], K, Type->Matrix ], 1, {} ]
	]
];	

Options[auxUniversalFA]={};
auxUniversalFA[ K_Alpha:$alphabet, opts:OptionsPattern[] ] := 
With[ {k = AlphabetCount[K]},
	DFA[ TSys[ 1, k, k, Table[{1},{k}], K, Type->Matrix ],1, {1} ] ];	
	
Options[auxQuotientFA]={Normalize:>$defaultnormalize};
auxQuotientFA[ {zz___String}, K_Alpha:$alphabet, opts:OptionsPattern[] ] := 
    auxQuotientFA[ ToIndex[{zz},K], K, opts ];

auxQuotientFA[ L:{{___Integer}...}, K_Alpha:$alphabet, opts:OptionsPattern[] ] := 
Module[{k,n,tr,Q,res},
	k = AlphabetCount[K];
	{Q,tr} = Closure[ Sort[L], Table[Evaluate[auxauxQuot[#,i]]&, {i,k}], 
                       Cayley->True, SelectOptions[Closure,opts] ];
	n = Length[Q];
    res = DFA[ TSys[n,k,k n,Normal@TransitionMatrix[ n, k, tr, Type->DFA ],K,Type->Matrix],
			1, PositionList[Q,Cases[Q,{___,{},___}] ] ]; 
    Switch[ OptionValue[Normalize],
        Full, res,
        _, SetStates[ res, ToWord[Q,K] ]
    ]
];
auxauxQuot[L_List,s_] := Union[ Rest /@  Cases[L,{s,___}] ];

auxFactorFA[ w_List, K_Alpha ] := 
With[ {k = AlphabetCount[K], n = Length[w]+1},
	FA[ TSys[ n, k, n, Pairs[ Range[n-1], w, Range[2,n] ], K ], All, All ]
];

auxPrefixFA[ w_List, K_Alpha ] := 
With[ {k = AlphabetCount[K], n = Length[w]+1},
	FA[ TSys[ n, k, n, Pairs[ Range[n-1], w, Range[2,n] ], K ], {1}, All ]
];

auxSuffixFA[ w_List, K_Alpha ] := 
With[ {k = AlphabetCount[K], n = Length[w]+1},
	FA[ TSys[ n, k, n, Pairs[ Range[n-1], w, Range[2,n] ], K ], All, {n} ]
];

auxScatteredFA[ w_List, K_Alpha ] := 
With[ {k = AlphabetCount[K], n = Length[w]+1},
	FA[ TSys[ n, k, n, 
		Sort[ Join[ Pairs[ Range[n-1], w, Range[2,n] ], Pairs[ Range[n-1], {0}, Range[2,n] ] ] ],
		K ], {1}, {n} ]
];


(* ::Subsection::Closed:: *)
(*GenerateFA*)


(* ::Text:: *)
(*Generate FA from transition relations (given as functions Q\[LongRightArrow] Q or Q \[LongRightArrow] \[GothicCapitalP](Q)).*)
(*Final states via selector predicate.*)


PackageSymbol[GenerateFA,
"GenerateFA[Q0,{f,g,..},A,fin]  constructs an FA on the closure Q of Q0 under {f,g,...} over alphabet A.
Predicate fin selects the final states in Q. {f,g,...} must have length the size of A."];


SyntaxInformation[GenerateFA] = {"ArgumentsPattern"->{_,_,_,_,OptionsPattern[]}};
Attributes[GenerateFA]={};
Options[GenerateFA]={Full->False,Type->FA,Normalize:>$defaultnormalize};
AllOptions[GenerateFA]={};


GenerateFA[ Q0_, del_List, K_Alpha, fin_, opts:OptionsPattern[]  ] := 
	If[ OptionValue[Type]===DFA,
		auxGenerateDFA[Q0,del,K,fin,SelectOptions[auxGenerateDFA,opts]],
		auxGenerateFA[Q0,del,K,fin,SelectOptions[auxGenerateFA,opts]]
	];

Options[auxGenerateFA]={Full->False,Normalize:>$defaultnormalize};
auxGenerateFA::uneqlen = "Length of function list not the same as alphabet size.";
auxGenerateFA[ Q0_List, del_List, K_Alpha, fin_, opts:OptionsPattern[]  ] := 
    Module[ {Q,k,n,tr,res},
	 k =  AlphabetCount[K];
	If[ Length[del]!= k, Message[GenerateFA::uneqlen]; Return[$Failed] ];
	{Q,tr} = Closure[ Q0, del, Cayley->True, SetClosure->True, InitialSet->True ];
	n = Length[Q];
	res = FA[  TSys[ n, k, Length[tr], tr, K ],
          		PositionList[Q,Q0], PositionList[Q,Select[Q,fin]]];
	Switch[  OptionValue[Normalize], 
		Full,  res, 
		_, SetStates[ res, Q ]
	]
];

Options[auxGenerateDFA]={Full->False,Normalize:>$defaultnormalize};
auxGenerateDFA::uneqlen = "Length of function list not the same as alphabet size.";
auxGenerateDFA[ q0_, del_List, K_Alpha, fin_, opts:OptionsPattern[]  ] := 
    Module[ {Q,k,n,tr,mat,res},
	 k =  AlphabetCount[K];
	If[ Length[del]!= k, Message[auxGenerateDFA::uneqlen]; Return[$Failed] ];
	{Q,tr} = Closure[ q0, del, Cayley->True ]; 
	n = Length[Q];
	mat = Thread[  ReplacePart[  ConstantArray[0,{n,k}], (Take[#,2]->Last[#])& /@ tr ] ];
	res = DFA[  TSys[ n, k, n k, mat, K, Type->Matrix ],
          		PositionOne[Q,q0], PositionList[Q,Select[Q,fin]]];
	Switch[  OptionValue[Normalize], 
		Full,  res, 
		_, SetStates[ res, Q ]
	]
];


(* ::Subsection::Closed:: *)
(*SemilinearDFA*)


(* ::Text:: *)
(*Counting is done via a semilinear set  A  \[Union]   (t + B + p \[DoubleStruckCapitalN] ).*)
(*Has shortcuts for: 1. straight count, 2. modular count.*)


PackageSymbol[SemilinearDFA,
"SemilinearDFA[w,{t,p,A,B},K,opts] constucts a counter automaton for word w and semilinear set 
(t,p,A,B) over alphabet K."];


SyntaxInformation[SemilinearDFA] = {"ArgumentsPattern"->{_,_.,_.,OptionsPattern[]}};
Attributes[SemilinearDFA]={};
Options[SemilinearDFA]={Normalize:>$defaultnormalize,Type->"Length",SubType->"Factor"};
AllOptions[SemilinearDFA]={};
SemilinearDFA::badopt = "Bad option `1` for SemilinearDFA.";


SemilinearDFA[_?EpsQ,__] := $Failed;
SemilinearDFA[ c_Integer?NonNegative, K_Alpha:$alphabet, opts:OptionsPattern[] ] := 
	SemilinearDFA[ {c+1,1,{c},{}}, K, opts ];
SemilinearDFA[ r_Integer?NonNegative, m_Integer?Positive, K_Alpha:$alphabet, opts:OptionsPattern[] ] := 
	SemilinearDFA[ {0,m,{},{r}}, K, opts ];
SemilinearDFA[ w_String, c_Integer?NonNegative, K_Alpha:$alphabet, opts:OptionsPattern[] ] := 
	SemilinearDFA[ ToIndex[w,K], {c+1,1,{c},{}}, K, opts ];
SemilinearDFA[ w_String,  r_Integer?NonNegative, m_Integer?Positive, K_Alpha:$alphabet, opts:OptionsPattern[] ] := 
	SemilinearDFA[ ToIndex[w,K], {0,m,{},{r}}, K, opts ];

SemilinearDFA[ w_String, {t_Integer?NonNegative,p_Integer?Positive,A_List,B_List},
				K_Alpha:$alphabet, opts:OptionsPattern[] ] := 
	SemilinearDFA[ ToIndex[w,K],{t,p,A,B}, K, opts ]; 
	
SemilinearDFA[ w_List,{t_Integer?NonNegative,p_Integer?Positive,A_List,B_List},
				K_Alpha:$alphabet, opts:OptionsPattern[] ] := 
(
	Assert[ SubsetQ[ Range[0,t-1], A ]];
	Assert[ SubsetQ[ Range[0,p-1], B ]];
	Switch[ OptionValue[Type],
		"Count", auxCounterDFA[w,{t,p,A,B},K,SelectOptions[auxCounterDFA,opts]],
		"Scattered", auxScatteredCounterDFA[w,{t,p,A,B},K,SelectOptions[auxScatteredCounterDFA,opts]],
		"Length", auxLengthDFA[{t,p,A,B},K,SelectOptions[auxLengthDFA,opts]],
		_, Message[SemilinearDFA::badopt, ToString@OptionValue[Type]]
	]
);		
SemilinearDFA[{t_Integer?NonNegative,p_Integer?Positive,A_List,B_List},
				K_Alpha:$alphabet, opts:OptionsPattern[] ] := 
		auxLengthDFA[{t,p,A,B},K,SelectOptions[auxLengthDFA,opts]];


Options[auxCounterDFA] = {Normalize:>$defaultnormalize,SubType->"Factor"};
auxCounterDFA[w_List,{t_Integer?NonNegative,p_Integer?Positive,A_List,B_List},K_Alpha:$alphabet, opts:OptionsPattern[] ] := 
Module[ {tp,n,k,hh,M,Q,convert,q0,tr,fa,mat,res},
	tp = t + p - 1;
	n = Length[w];
	k = AlphabetCount[K];
	tr = Pairs[ Range[0,n-1], w, Range[n] ];   (* backbone transitions *)
	tr = Sort[Join[ CartesianProduct[ {0},Range[k],{0}],tr]];
	tr = MapTransitions[ tr, #+1& ];
	fa =FA[ TSys[ n, k, Length[tr], tr, K ], {1}, {n+1} ];
	M = MinimizeFA[ fa ];
	Q = CartesianProduct[ Range[StateCount[M]], Range[0,tp] ];

	Switch[ OptionValue[SubType],
	"Factor", convert[{r_,s_,q_}] := Table[ {{r,i},s,{q,TransMod[i+1,t,p]}}  , {i,0,tp} ]   /; 
			MemberQ[FinalStateList[M],q],
	"FactorNoOverlap",
		q0 = InitialState[M];
		convert[{r_,s_,q_}] := Table[ {{r,i},s,{q0,TransMod[i+1,t,p]}}  , {i,0,tp} ]   /; 
			MemberQ[FinalStateList[M],q]
	];
	convert[{r_,s_,q_}] := Table[ {{r,i},s,{q,i}}, {i,0,tp} ] ;

	tr = FlattenOne[ convert/@ TransitionList[M] ];
	AssignFunction[ hh, Q, Range[Length[Q]] ];
	tr = MapTransitions[ tr, hh ];
	mat = TransitionsToSparse[ Length[Q], AlphabetCount[K], tr, Type->DFA ];
	res = DFA[ TSys[ Length[Q], AlphabetCount[K], Length[tr], mat, K, Type->Matrix ],
		PositionOne[Q,{InitialState[M],0}],
		PositionList[ Q, Select[ Q, MemberQ[Join[A,B+t], TransMod[#[[2]],t, p ]]& ] ] ];
	Switch[ OptionValue[Normalize],
		Full, res,
		_, SetStates[res,Q] 
	]
];


Options[auxScatteredCounterDFA]={Normalize:>$defaultnormalize};
auxScatteredCounterDFA[ W_List, {t_Integer?NonNegative,p_Integer?Positive,A_List,B_List}, 
						K_Alpha:$alphabet, opts:OptionsPattern[]] :=
Module[ {k,n,mask,delta},
    k = AlphabetCount[K];
    n  = Length[W];
    mask[i_] := mask[i] = ToBitVector[Union@Flatten@Position[W,i],n];
    delta[i_][pv_] := TransMod[#,t,p]& /@ (pv + Most[Prepend[pv,1] Append[mask[i],0]]);
    With[ {fin = Join[A,t+B]}, 
        GenerateFA[ Table[0,{n}], Table[ Evaluate[delta[i]],{i,k}], K,
                    MemberQ[fin,Last[#]]&, Type->DFA,SelectOptions[GenerateFA,opts] ]
    ]
];


Options[auxLengthDFA]={Normalize:>$defaultnormalize};
auxLengthDFA[ {t_Integer?NonNegative,p_Integer?Positive,A_List,B_List},
			K_Alpha:$alphabet, opts:OptionsPattern[] ] := 
Module[ {tp,k,mat,res},
	k = AlphabetCount[K];
	tp = t + p - 1;
	mat = Table[ TransMod[i+1,{t,p}],{k},{i,0,tp} ]+1;
	res = DFA[ TSys[ tp+1, k, tp k, mat, K, Type->Matrix ], 1,Join[A,B+t]+1 ];
	Switch[ OptionValue[Normalize],
		Full, res,
		_, SetStates[res,Range[0,tp]] 
	]
];


(* ::Subsection::Closed:: *)
(*PositionFA*)


(* ::Text:: *)
(*Input  {Subscript[a, 1], \[Ellipsis],Subscript[a, r]}  and  {Subscript[p, 1],\[Ellipsis],Subscript[p, r]}  where the positions Subscript[p, i] are either all positive or all negative.*)


PackageSymbol[PositionFA,
"PositionFA[a,p,A,opts] constucts the x[p]=a automaton for alphabet A."];


SyntaxInformation[PositionFA] = {"ArgumentsPattern"->{_,_,_.,OptionsPattern[]}};
Attributes[PositionFA]={};
Options[PositionFA]={Normalize:>$defaultnormalize};
AllOptions[PositionFA]={};


PositionFA[ a_Integer?Positive, p_Integer, K_Alpha:$alphabet, opts:OptionsPattern[] ] :=
	PositionFA[ {a}, {p}, K, opts ];
PositionFA[ W_List, P_List, K_Alpha:$alphabet, opts:OptionsPattern[] ] :=
Module[{n,A,A1,A2,A3,k,norm,res},
	Assert[Length[W]==Length[P]];
	k  = AlphabetCount[K];
	n  = Max[ Abs[P] ];
	PP = If[#<0,n+#+1,#]& /@ P;
	A1 = Pairs[ PP-1,W,PP ];
	A2  = Thread[ {Table[#-1,{k}],Range[k],Table[#,{k}]} ]& /@ Complement[Range[n],PP ];
	A3 = If[ Max[P]>0, 
		CartesianProduct[{n},Range[k],{n}],
		CartesianProduct[{0},Range[k],{0}]
	];
	A = Sort[ MapTransitions[ Join[ A1, FlattenOne[A2],A3 ], #+1& ] ];
    res =  FA[ TSys[ n+1, k, Length[A], A, K ], {1}, {n+1} ];
	Switch[ OptionValue[Normalize],
		Full, res, 
		_, SetStates[ res, Range[0,n]] 
	]
];


(* ::Subsection::Closed:: *)
(*CirculantFA*)


PackageSymbol[CirculantFA,
"CirculantFA[n,{s1,...,sk],opts] constucts the circulant automaton on n states with strides 
s1, ..., sk."];


SyntaxInformation[CirculantFA] = {"ArgumentsPattern"->{_,_.,OptionsPattern[]}};
Attributes[CirculantFA]={};
Options[CirculantFA]={Labels->None};
AllOptions[CirculantFA]={};


CirculantFA[ n_Integer?Positive, S:{__Integer},opts:OptionsPattern[] ] := 
Module[ {tr,k,labs},
	k = Length[S];
	labs = OptionValue[Labels];
	If[ labs === None, 
		labs = Table[ i, {i,k},{n} ] 
	];
	tr = FlattenOne[Table[ {p,labs[[i,p]],Mod[p+S[[i]],n,1]}, {p,n}, {i,k} ]];
	FA[ TSys[ n, k, n k, tr, Alpha[k] ], All, All ]
];


(* ::Subsection::Closed:: *)
(*ToFactorFA*)


(* ::Text:: *)
(*Prefix/Suffix/Factor			language of all such*)
(*NoPrefix/NoSuffix/NoFactor	language of all proper such *)


PackageSymbol[ToFactorFA,
"ToFactorFA[M,opts]  converts a FSM M into a machine that accepts the language of all factors of words in the language of M."];


SyntaxInformation[ToFactorFA] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Attributes[ToFactorFA]={};
Options[ToFactorFA]={Normalize:>$defaultnormalize,Type->"Factor"};
AllOptions[ToFactorFA]={};


ToFactorFA[ M_?FSMQ,  opts:OptionsPattern[] ] :=
  With[ {norm = OptionValue[Normalize]},
    Switch[  OptionValue[Type], 
      "Factor",       factorMFA[M,norm],
      "NoFactor",  properFactorMFA[M,norm],
      "Suffix",      suffixMFA[M,norm],
      "NoSuffix",  properSuffixMFA[M,norm],
      "Prefix",      prefixMFA[M,norm],
      "NoPrefix",  properPrefixMFA[M,norm]
   ]];

suffixMFA[ M_?FSMQ, norm_ ] := Module[ {m = TrimFA[M]}, SetInitialFA[ m, All ]];              
prefixMFA[M_?FSMQ,norm_] := Module[ {m =TrimFA[M]}, SetFinalFA[ m, All ]];                  
factorMFA[M_?FSMQ,norm_] := Module[ {m =TrimFA[M]}, SetInitialFinalFA[ m, All, All ]];              

properSuffixMFA[ M_?FSMQ, norm_ ] := 
    	ReverseFA[properPrefixMFA[ReverseFA[M],norm]];

properPrefixMFA[ MM_?FSMQ, norm_ ] := 
    Module[ {M,tr,F},
      	M  = ToFA[DeterminizeFA[MM,Normalize-> norm] ];
      	tr = TransitionList[M];
      	F  = FinalStateList[M];
          With[ {newtr = Complement[ tr, Select[ tr, MemberQ[F,First[#]]& ] ]},
          	SetTransitionSystem[ M, 
                 TSys[ StateCount[M], AlphabetCount[M], Length[newtr], newtr, GetAlphabet[M]] ] ]
      ];

properFactorMFA[ MM_?FSMQ, norm_ ] := 
Module[ {ini,fin,ff,delta},
    AssignTransitionFunction[ delta, MM ];
    ini = InitialStateList[MM];
    fin = FinalStateList[MM];
    ff[_][{{},{}}] := {{},{}};
    ff[s_][ {P_,PP_} ] :=
    If[ Intersection[P,fin]=!={} || Intersection[PP,fin]=!={}, 
        {{},{}},
        { delta[P,s] , Union[delta[PP,s],ini]} 
    ];
    GenerateFA[ {ini,{}}, Table[  Evaluate[ff[s]], {s,AlphabetCount[MM]} ], GetAlphabet[MM],
        		(Intersection[fin,#[[1]]]=!={} && Intersection[fin,#[[2]]]==={})& , 
        		Type->DFA, Normalize->norm ]
];


(* ::Subsection::Closed:: *)
(*ToFrontierDFA*)


PackageSymbol[ToFrontierDFA,
"ToFrontierDFA[M,opts]  converts DFA M into the corresponding frontier automaton (g,F)."];


SyntaxInformation[ToFrontierDFA] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Attributes[ToFrontierDFA]={};
Options[ToFrontierDFA]={Periodic->False};
AllOptions[ToFrontierDFA]={};


ToFrontierDFA[ m_DFA, opts:OptionsPattern[] ] := 
	If[ OptionValue[Periodic], 
		auxPeriodicFrontierDFA[m],
		auxPlainFrontierDFA[m]
	];


auxPeriodicFrontierDFA[M_DFA]:=
Module[{k,K,A,act,act0,QQ,frnt,q,wi,int,next,branch,trf,trb,rk,rank},
	k = AlphabetCount[M];
	A = TransitionMatrix[M];
	act = {{{},InitialState[M]}};
	QQ = act;
	rk = 1;
	rank[{}] = rk++;
	
	next[{w_List,p_Integer}]:=
	Do[ 
		q = A[[i,p]];
		wi = Append[w,i];
		branch = CartesianProduct[ auxListPrefixes[w],{q}];
		If[(int=Intersection[QQ,branch])=!={},
			Sow[ {rank[w],i,rank[First[Last[int]]]},"back"],
			rank[wi] = rk++;
			Sow[ {rank[w],i,rank[wi]},"forw"];
			AppendTo[act0,{wi,q}];
		],
		{i,k}
	];

	trb = Reap[  
		trf = Reap[ 
			While[act =!= {},
				act0 = {};
				Scan[next,act];
				QQ = QQ \[Union] act0;
				act = act0 ],
	"forw" ];, "back" ];
	trf = If[ trf[[2]]=!={}, trf[[2,1]], {} ];
	trb = If[ trb[[2]]=!={}, trb[[2,1]], {} ];
	{trf,trb,QQ}
];

auxListPrefixes[L_List] := Table[ Take[ L, i ], {i,0,Length[L]} ];


auxPlainFrontierDFA[M_DFA]:=
Module[{k,K,A,act,act0,QQ,frnt,q,wi,next,int,trf,trb,rk,rank},
	k = AlphabetCount[M];
	A = TransitionMatrix[M];
	act = {{{},InitialState[M]}};
	QQ = act;
	rk = 1;
	rank[{}] = rk++;
	rank[_] := 0;
	
	next[{w_List,p_Integer}]:=
	Do[ 
		q = A[[i,p]];
		wi = Append[w,i];
		int = Cases[ Join[QQ,act0], {_,q} ];
		If[ int =!= {},
			Sow[ {rank[w],i,rank[First[Last[int]]]},"back"],
			rank[wi] = rk++;
			Sow[ {rank[w],i,rank[wi]},"forw"];
			AppendTo[act0,{wi,q}];
		],
		{i,k}
	];

	trb = Reap[  
		trf = Reap[ 
			While[act =!= {},
				act0 = {};
				Scan[next,act];
				QQ = QQ \[Union] act0;
				act = act0 ],
	"forw" ];, "back" ];
	trf = If[ trf[[2]]=!={}, trf[[2,1]], {} ];
	trb = If[ trb[[2]]=!={}, trb[[2,1]], {} ];
	{trf,trb,QQ}
];


(* ::Section::Closed:: *)
(*Graphs*)


(* ::Subsection::Closed:: *)
(*TransitionsToEdges*)


(* ::Text:: *)
(*transitions are normalized  {p,s,q} \[Element] [n] \[Cross] [k] \[Cross] [n]*)


PackageSymbol[TransitionsToEdges,
"TransitionsToEdges[t,opts] converts a transition to a directed edge."];


SyntaxInformation[TransitionsToEdges] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[TransitionsToEdges]={Labeled->True,VertexTransformation->Identity,
LabelTransformation->Identity, Simple->True, Table->False };
AllOptions[TransitionsToEdges]={};


TransitionsToEdges[{p_Integer,s_Integer,q_Integer},opts:OptionsPattern[]] := 
With[{vt=OptionValue[VertexTransformation],lt=OptionValue[LabelTransformation]},
If[OptionValue[Labeled],
	{DirectedEdge[vt[p],vt[q]],lt[s]},
		DirectedEdge[vt[p],vt[q]]]
];

TransitionsToEdges[L:{{_Integer,_Integer,_Integer}...},opts:OptionsPattern[]] := 
With[{tte=TransitionsToEdges[#,opts]&},
	If[ OptionValue[Table], Return[ Map[ First, GatherBy[ tte/@L, Last ], {2} ] ] ];
	If[ OptionValue[Simple], Union[tte/@L], tte/@ L  ] ];

TransitionsToEdges[ T_TSys, opts:OptionsPattern[]] := 
	TransitionsToEdges[ TransitionList[T], opts ];
	
TransitionsToEdges[ M_?FSMQ, opts:OptionsPattern[]] := 
	TransitionsToEdges[ TransitionSystem[M], opts ];


(* ::Subsection::Closed:: *)
(*TransitionsToGraph*)


(* ::Text:: *)
(*transitions are normalized  {p,s,q} \[Element] [n] \[Cross] [k] \[Cross] [n]*)


PackageSymbol[TransitionsToGraph,
"TransitionsToGraph[t,opts] converts a finite state machine to a directed graph."];


SyntaxInformation[TransitionsToGraph] = {"ArgumentsPattern"->{_,_.,OptionsPattern[]}};
Options[TransitionsToGraph]={Labeled->True,VertexTransformation->Identity,
LabelTransformation->Identity};
AllOptions[TransitionsToGraph]={};


TransitionsToGraph[n_Integer, L:{{_Integer,_Integer,_Integer}...}, opts:OptionsPattern[]]:=
	Graph[ Range[n], TransitionsToEdges[L,Labeled->False, Simple->True ], GraphLayout->None ];

TransitionsToGraph[ T_TSys, opts:OptionsPattern[]] := 
	TransitionsToGraph[ StateCount[T], TransitionList[T], opts ];

TransitionsToGraph[ M_?FSMQ, opts:OptionsPattern[]] := 
	TransitionsToGraph[ TransitionSystem[M], opts ];


(* ::Subsection::Closed:: *)
(*NonTrivialComponentQ*)


(* ::Text:: *)
(*should be built-in*)


PackageSymbol[NonTrivialComponentQ,
"NonTrivialComponentQ[G,L] tests whether vertex set L represents a non-trivial component of G."];


SyntaxInformation[NonTrivialComponentQ] = {"ArgumentsPattern"->{_,_,OptionsPattern[]}};
Options[NonTrivialComponentQ]={};
AllOptions[NonTrivialComponentQ]={};


NonTrivialComponentQ[ G_Graph, L_List ] := 
	Length[L] > 1 || EdgeQ[ G, DirectedEdge[ L[[1]], L[[1]] ] ];


(* ::Subsection::Closed:: *)
(*CondensationGraph*)


(* ::Text:: *)
(*maybe drop highlight*)
(*is option for terminal components right? *)


PackageSymbol[CondensationGraph,
"CondensationGraph[G] computes the condensation of digraph G."];


SyntaxInformation[CondensationGraph] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[CondensationGraph]={Full->False,Terminal->False,GraphLayout->Automatic};
AllOptions[CondensationGraph]={};


CondensationGraph[G_, opts:OptionsPattern[] ] := 
Module[ {scc,cmp,n,GG,ntscc},
	scc = ConnectedComponents[G];
	n = VertexCount[G];
	AssignFunction[ cmp, Range[n], Table[ scc[[ PositionOne[scc,v]]], {v,n} ] ];
	GG = Graph[ scc, 
		DeleteCases[ Union[Map[ cmp, EdgeList[G], {2} ]], DirectedEdge[x_,x_] ],
		GraphLayout->OptionValue[GraphLayout] ];
	ntscc = PositionList[ scc, Select[scc,NonTrivialComponentQ[G,#]& ] ];
	If[ OptionValue[Terminal],
		With[ {pos = Flatten@Position[VertexOutDegree[GG],0]},
			Assert[ pos =!= {} ];
			Return[ VertexList[GG][[pos[[1]]]] ] ] 
	];
	If[ OptionValue[Full],
		{GG,scc,ntscc},
		HighlightGraph[ GG, ntscc ]
	]
];


(* ::Subsection::Closed:: *)
(*ShowGraph*)


(* ::Text:: *)
(*maybe drop highlight*)
(*is option for terminal components right? *)


PackageSymbol[ShowGraph,
"ShowGraph[G,opts] displays the graph G."];


SyntaxInformation[ShowGraph] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[ShowGraph]={GraphLayout->Automatic};
AllOptions[ShowGraph]={};


ShowGraph[G_Graph,opts:OptionsPattern[] ] := SetProperty[G,GraphLayout->OptionValue[GraphLayout]];


(* ::Section::Closed:: *)
(*Transducers*)


(* ::Text:: *)
(*Only input-deterministic, sequential, alphabetic: *)
(*	- transition system over product alphabet,*)
(*	- single initial state*)
(**)
(*Generalize to lexical (allow \[Epsilon]). *)


(* ::Subsection::Closed:: *)
(*Transducer*)


PackageSymbol[TD,
"TD[args] represents a transducer."];


SyntaxInformation[TD] = {"ArgumentsPattern"->{_,_,_, OptionsPattern[]}};
Options[TD] = {Props->{}};
AllOptions[TD]={Props->{{},"Minimal","Unambiguous"}};

(*  TD[ TSys[ n, k, t, tr, A ], q0, All ]   *) 


(* ::Subsection::Closed:: *)
(*ApplyTransduction*)


(* ::Text:: *)
(*Assumes product alphabet *)


PackageSymbol[ApplyTransduction,
"ApplyTransduction[T,L,opts] applies transduction defined by T to word L."];


SyntaxInformation[ApplyTransduction] = {"ArgumentsPattern"->{_,_,OptionsPattern[]}};
Options[ApplyTransduction]={Full->False};
AllOptions[ApplyTransduction]={};


ApplyTransduction[ A_TD, L_List, opts:OptionsPattern[] ] := 
Module[ {q0,M, u, pp},
	q0 = InitialStateList[A][[1]];
	M = auxTransducerToMatrix[A];
	{u,pp} = Thread@Rest@FoldList[  M[[ #1[[-1]],#2]]&,{{},q0}, L ];
	If[ OptionValue[Full], 
		{ u, Prepend[pp,q0] },
		u
	]
];


(* ::Text:: *)
(*Q \[Cross] Subscript[K, 1]  matrix over Subscript[K, 2] \[Cross] Q*)


auxTransducerToMatrix[ A_TD ] := 
With[ {M = Array[ {}&, {StateCount[A],AlphabetTracks[A][[1]]} ]},
With[ {f = Association[ Rule@@@Pairs[ Range[AlphabetCount[K]],CartesianProduct@@AlphabetTracks[A] ] ]},
	ReplacePart[ M, (Take[#,2]->Drop[#,2]&) /@ Flatten /@ 
		Flatten /@ MapTransitions[ TransitionList[A], Identity, f ] ]
]];

(*auxTransducerToMatrix[ A_TD ] := 
With[ {M = Array[ {}&, {StateCount[A],AlphabetTracks[A][[1]]} ]},
	ReplacePart[ M, (Take[#,2]->Drop[#,2]&) /@ Flatten /@ 
		auxUnpackTracks[TransitionList[A],GetAlphabet[A]] ]
];
auxUnpackTracks[s_Integer, A_Alpha] := 
	UnrankCartesian[s,AlphabetTracks[A],ZeroIndexed->False];
auxUnpackTracks[{p_Integer,s_Integer,q_Integer}, A_Alpha] := 
	{p,UnrankCartesian[s,AlphabetTracks[A],ZeroIndexed->False],q};
auxUnpackTracks[L:{{_Integer,_Integer,_Integer}...}, A_Alpha] := 
	auxUnpackTracks[#,A]& /@ L;*)


(* ::Subsection::Closed:: *)
(*AssignTransduction*)


(* ::Text:: *)
(*Assumes product alphabet.*)


PackageSymbol[AssignTransduction,
"AssignTransduction[t,T,opts] assigns transduction defined by T to symbol t."];


SyntaxInformation[AssignTransduction] = {"ArgumentsPattern"->{_,_,OptionsPattern[]}};
Attributes[AssignTransduction]={HoldFirst};
Options[AssignTransduction]={Full->False};
AllOptions[AssignTransduction]={};


AssignTransduction[ ff_, A_TD, opts:OptionsPattern[] ] := 
Module[ {q0, n, K, unf, M},
	q0 = InitialStateList[A][[1]];
	n = StateCount[A];
	K = GetAlphabet[A];
	Assert[ AlphabetTrackCount[K]==2 ];
	unf = Association[ Rule@@@Pairs[ Range[AlphabetCount[K]],CartesianProduct@@AlphabetTracks[A] ] ];
	M = ConstantArray[{},{n,AlphabetTracks[K][[1]]}];
	M = ReplacePart[ M,  Take[#,2]-> Drop[#,2]&  /@ Flatten /@ 
			MapTransitions[ TransitionList[A], Identity, unf ]];
	ff[L_List] := With[ {
	res = Thread@Rest@FoldList[  M[[ #1[[-1]],#2]]&, {{},q0}, L ]},
	If[ OptionValue[Full], 
		{ res[[1]], Prepend[res[[2]],q0] },
		res[[1]]
	]];
];


(* ::Section::Closed:: *)
(*Automata Operations*)


(* ::Subsection::Closed:: *)
(*ToKernelFA*)


PackageSymbol[ToKernelFA,
"ToKernelFA[A,K,opts] generates the K kernel automaton of A."];


SyntaxInformation[ToKernelFA] = {"ArgumentsPattern"->{_,_,OptionsPattern[]}};
Attributes[TestPropertyFA]={};
Options[ToKernelFA]={Full->False};
AllOptions[TestPropertyFA]={};


ToKernelFA[M_FA, {xx__Integer}, opts : OptionsPattern[]] := 
	ToKernelFA[M, ({#1} &) /@ {xx}, opts];
ToKernelFA[M_FA, opts : OptionsPattern[]] := 
	ToKernelFA[M, ({#1} &) /@ InitialStateList[M], opts];
ToKernelFA[M_FA, {LL__List}, opts : OptionsPattern[]] :=
  Module[{k, n, TT, nn, h, hh, dp, q, j, next, newT, current, fa, QQ},
   k = AlphabetCount[M]; 
   n = StateCount[M]; 
   TT = TransitionMatrix[M]; 
   nn = Length[{LL}]; 
   AssignFunction[h, Range[nn], {LL}]; 
   AssignFunction[hh, {LL}, Range[nn]]; 
   Scan[(dp[#] = 0) &, Range[nn]]; 
   h[_] = 0; hh[_] = 0; 
   next[a_] :=
    ( q = Union[Flatten[TT[[a, h[current]]]]];
      j = If[hh[q] == 0, h[++nn] = q; dp[nn] = dp[current] + 1; 
             hh[q] = nn, hh[q]]; 
      AppendTo[newT, {current, a, j}];
     );
   newT = {};
   current = 0;
   While[current < nn,
    	++current; Scan[next, Range[k]];
    ];
   QQ = h /@ Range[nn]; 
   fa = FA[ TSys[ nn, k, Length[newT], newT, GetAlphabet[M]], 
     	PositionList[QQ, {LL}],
     	 PositionList[QQ, Select[QQ, ! DisjointQ[#, FinalStateList[M]] &]] ];
   If[ OptionValue[Full], SetStates[fa, QQ] ];
   fa
   ];


(* ::Subsection::Closed:: *)
(*ReverseFA*)


(* ::Text:: *)
(*Vertex induced, only normalized*)


PackageSymbol[ReverseFA,
"ReverseFA[M] constucts the reversal of the automaton M."];


SyntaxInformation[ReverseFA] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[ReverseFA]={};
AllOptions[ReverseFA]={};


ReverseFA[ M_FA, opts:OptionsPattern[] ] := 
	ReplacePart[ M, {{1,4} -> Reverse /@ TransitionList[M], -2->M[[-1]], -1->M[[-2]]}  ];


ReverseFA[ M_DFA, opts:OptionsPattern[] ] := 
	FA[ TSys[StateCount[M],AlphabetCount[M],TransitionCount[M],  
        Reverse /@ TransitionList[M], GetAlphabet[M]], M[[-1]], {M[[-2]]}  ];


(* ::Subsection::Closed:: *)
(*EpsilonEliminationFA*)


(* ::Text:: *)
(*should check properties*)


PackageSymbol[EpsilonEliminationFA,
"EpsilonEliminationFA[M]  removes eps-transitions from the automaton M."];


SyntaxInformation[EpsilonEliminationFA] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Attributes[EpsilonEliminationFA]={Listable};
Options[EpsilonEliminationFA]={};
AllOptions[EpsilonEliminationFA]={};


EpsilonFreeQ[ _DFA] := True;
EpsilonFreeQ[ M_FA ] := Cases[TransitionList[M], {_,0,_} ]==={};

EpsilonEliminationFA[ M_FA, opts:OptionsPattern[] ] :=
    Module[ {n,ini,eps,neps,gr,grt,extend,tr},
	If[ EpsilonFreeQ[M], Return[M] ];
	n   = StateCount[M];
	ini = InitialStateList[M];
	eps = Cases[TransitionList[M], {_,0,_} ];
	neps = DeleteCases[ TransitionList[M], {_,0,_} ];
	gr = TransitionsToGraph[ n, eps ];
	grt = TransitiveClosureGraph[gr];
	extend[ {p_,s_,q_} ] := Table[  {p,s,qq}, {qq,VertexOutComponent[grt,q]} ];
	tr = FlattenOne[extend/@neps];
	FA[ TSys[ n, AlphabetCount[M],Length[tr],tr, GetAlphabet[M]], 
		Union[ Table[VertexOutComponent[grt,p],{p,ini}]], FinalStateList[M] ]	
];


(* ::Subsection::Closed:: *)
(*DeterminizeFA*)


(* ::Text:: *)
(*should check properties*)
(*should produce sparse array for partial DFAs*)


PackageSymbol[DeterminizeFA,
"DeterminizeFA[M]  determinizes the finite state machine M."];


SyntaxInformation[DeterminizeFA] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Attributes[DeterminizeFA]={Listable};
Options[DeterminizeFA]={Full->False,Normalize:>$defaultnormalize,SizeOnly->False};
AllOptions[DeterminizeFA]={};


DeterminizeFA[ M_DFA, opts:OptionsPattern[] ] := M;

DeterminizeFA[ MM_FA, opts:OptionsPattern[] ] :=
    Module[ {ff,k,n,Q,tt,nn,fin,h,M,res},
    M = If[ EpsilonFreeQ[MM], MM, EpsilonEliminationFA[MM] ];
	n = StateCount[M];
	k = AlphabetCount[M];
	ff = SymbolList[ "fdeterminizefa", k ]; 
	TransitionFunctionList[ ff, n, k, TransitionList[M] ];
	{Q,tt} = Closure[ InitialStateList[M], ff, Cayley->True ];
	nn = Length[Q];
	If[ OptionValue[SizeOnly], Return[nn] ];
	tt = TransitionMatrix[ nn, k, tt, Type->DFA ];
	fin = PositionList[Q, Select[Q,!DisjointQ[FinalStateList[M],#]& ] ];
    res = DFA[ TSys[ nn, k, nn k, tt, GetAlphabet[M], Type->Matrix ], 1, fin ];
	Switch[ OptionValue[Normalize], 
        Full,      res,
        Automatic, SetStates[ res, Q ],
        None, 
            AssignFunction[ h, Range[StateCount[M]], StateList[M] ];
            SetStates[ res, Map[h,Q,{2}]]
    ]
];


(* ::Subsection::Closed:: *)
(*LanguageFA*)


(* ::Text:: *)
(*add various Implementations*)
(*reorganize options logic*)


PackageSymbol[LanguageFA,
"LanguageFA[M,n,opts] returns the part of the language of automaton A."];


SyntaxInformation[LanguageFA] = {"ArgumentsPattern"->{_,_,OptionsPattern[]}};
Options[LanguageFA]={SizeOnly->False,Words->True,Multiplicity->False};
AllOptions[LanguageFA]={};


LanguageFA[ MM_?FSMQ, ln_, opts:OptionsPattern[] ] := 
With[ {M = If[ EpsilonFreeQ[MM], MM, EpsilonEliminationFA[MM] ], 
		rng = ParseRange[ln]},
	If[ OptionValue[SizeOnly], 
		Return[ auxLanguageSize[M, rng ] ] ];
	If[ OptionValue[Multiplicity], 
		Return[ auxLanguageMult[M, rng ] ] ];
	auxLanguageFA[ M, rng, opts ]
];


Options[auxLanguageFA] = {Words->True};
auxLanguageFA[ M_?FSMQ, {n1_,n2_}, opts:OptionsPattern[] ] := 
Module[{LLL,MM,tr,fin,ini,res,auxExtendPath,auxExtendTrans},
	auxExtendPath[P_List] :=  Join[ Most[P],#]& /@  auxExtendTrans[Last[P]];
	auxExtendTrans[p_Integer] := auxExtendTrans[p] = Rest/@Cases[ tr, {p,__} ];
	MM =  TrimFA[M];
(*debugPrint["lfa trim",MM];*)
	ini = Thread[{InitialStateList[MM]}];
	fin = FinalStateList[MM];
	If[ ini === {{}} || fin === {}, 
		Return[ If[ n1 == n2, {}, Table[ {}, {n2-n1+1} ]] ] ];
	tr =  TransitionList[MM];
(*debugPrint["lfa trans",tr];*)
	LLL = NestList[ Union@FlattenOne[Table[auxExtendPath[P],{P,#}]]&, ini, n2+1 ];
	res = If[ n1 == n2, 
		Union[ Most/@Select[ LLL[[n1+1]], MemberQ[fin,Last[#]]& ]],   (* no union: multiplicity *)
		Table[  Union[Most/@Select[ LLL[[i]], MemberQ[fin,Last[#]]& ]], {i,n1+1,n2+1} ]
	];
	If[ OptionValue[Words],
		If[res==={},Return[{}]];
        ToWord[ res, GetAlphabet[M] ],
		res 
	]
];

auxLanguageSize[ M_FA, {n1_,n2_}, opts:OptionsPattern[] ] := 
	auxLanguageSize[ DeterminizeFA[M], {n1,n2}, opts ]; 
auxLanguageSize[ M_DFA, {n1_,n2_}, opts:OptionsPattern[] ] := 
Module[ {MM,n,A,ini,fin},
	MM = TrimFA[M];
	n = StateCount[MM];
	A = SparseArray[ Rule@@@Tally[Drop[#,{2}]& /@ TransitionList[MM]], {n,n} ];
	ini = ToBitVector[InitialStateList[MM],Range[n]];
	fin = ToBitVector[FinalStateList[MM],Range[n]];
	If[ n1 == n2, 
		ini.MatrixPower[A,n1].fin,
		ini.If[#==0,IdentityMatrix[n],MatrixPower[A,#]].fin& /@ Range[n1,n2]
	]
];

auxLanguageMult[M_FA,{lo_Integer,hi_Integer}]:=
Module[{alph,k, Ini,Fin,A,prep,LL,words},
	alph=AlphabetList[M];
	k=AlphabetCount[M];
	Ini=InitialStateList[M];
	Fin=FinalStateList[M];
	A=Thread@TransitionMatrix[M]; 
	prep[{a_,L_}]:=Prepend[#,a]&/@L;
	LL[0,p_,q_]:=LL[0,p,q]=If[p==q,{{}},{}];
	LL[s_,p_,q_]:=LL[s,p,q]=
		With[ {tmp=Apply[Join,Map[LL[s-1,#,q]&,A[[p]],{2}],1]},
			FlattenOne[prep/@Pairs[Range[k],tmp]] ];
	words[s_]:=StringJoin@@alph[[#]]&/@FlattenOne[Map[LL[s,#[[1]],#[[2]]]&,CartesianProduct[Ini,Fin]]];
	If[lo==hi,
		Frequencies[ words[lo] ],
		Frequencies/@words/@Range[lo,hi]
	]
];


(* ::Subsection::Closed:: *)
(*MinimizeFA*)


PackageSymbol[MinimizeFA,
"MinimizeFA[M,opts]  minimizes the finite state machine M. May involve determinization."];


SyntaxInformation[MinimizeFA] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Attributes[MinimizeFA]={Listable};
Options[MinimizeFA]={DoTrace->False,Normalize:>$defaultnormalize};
AllOptions[MinimizeFA]={};


MinimizeFA[ M_DFA, opts:OptionsPattern[] ] :=    
With[{acc = TrimFA[ M, Type->Accessible ]},
	If[ StateCount[acc] < StateCount[M],
		MinimizeDFA[ acc, SelectOptions[MinimizeDFA,opts] ],
		MinimizeDFA[ M, SelectOptions[MinimizeDFA,opts] ]
	]
];

MinimizeFA[ M_FA, opts:OptionsPattern[] ] := 
        MinimizeDFA[ DeterminizeFA[ M, SelectOptions[DeterminizeFA,opts,{Full}]],opts];


(* ::Subsection::Closed:: *)
(*MinimizeDFA*)


(* ::Text:: *)
(*about 15% slower when EquivaleneToIndex[] is used*)


PackageSymbol[MinimizeDFA,
"MinimizeDFA[M,opts]  minimizes the DFA M."];


SyntaxInformation[MinimizeDFA] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Attributes[MinimizeDFA]={Listable};
Options[MinimizeDFA]={DoTrace->False,Normalize:>$defaultnormalize};
AllOptions[MinimizeDFA]={};


MinimizeDFA[ M_DFA, opts:OptionsPattern[] ] :=    
Module[ {norm,trace,trc,n,A,findpos,kernel,refine,fin,p1,p2,part,nn,hhh,MM,ff,LL},

    norm  = OptionValue[Normalize];  
    trace = OptionValue[DoTrace];  

    trc = {};
    n = StateCount[ M ];
    A = TransitionsRaw[ M ];
    If[ Head[A]===SparseArray, A = Normal[A] ];
    
(*  equivalence relation represented by canonical kernel function *)       
(*  strangely faster than ranking kernel *)       
	findpos[{a_,b_}] := If[ hhh[b]==0, hhh[b]=a, hhh[b] ];       
    
	kernel[ L_List ] := 
    (  Clear[hhh];
       hhh[_] := 0;
       LL = Pairs[ Range[Length[L]], L ];
       hhh[First[LL]] = 1;
       findpos /@ LL  );

(*  refine via whole alphabet *)           
    refine[s_] := 
    With[ {B = Thread[ Prepend[ s[[#]]& /@ A, s ] ]},
			If[ trace, AppendTo[trc,B] ];
			kernel[B] ];
    
(*  initialize characteristic function of F, Q-F *)
	fin = FinalStateList[M];
    p1 = Min[ fin ];
    If[ p1=!=1, p2 = 1, p2 = Min[ Complement[ Range[n], fin ]]];
    part  = If[ MemberQ[fin,#],p1,p2]& /@ Range[n];
    
(*  refine partition until no new classes occur *)
    part = FixedPoint[ refine, part, 5000 ];

(*  switch to ranking kernel, renumber *)
    MM = auxStateMergeDFA[ M, EquivalenceToIndex[part], OptionValue[Normalize] ];
    If[ OptionValue[DoTrace],  { MM, trc }, MM ]
];


auxStateMergeDFA[ M_DFA, equ_List, norm_  ] := 
Module[ {n,nn,k,tr,h,hh,ini,fin,Q,res}, 
    n  = StateCount[M];
    k  = AlphabetCount[M];
    tr = TransitionsRaw[M];
    If[ GetOptionValue[TransitionSystem[M],Type] === Matrix, 
        tr = Flatten /@ Normal@TransitionMatrix[M] ]; 
    nn = Max[equ];
    AssignFunction[ h, Range[n], equ ];
    Scan[ (hh[h[#]]=#)&, Reverse[Range[n]] ];
    tr   = Thread@Map[ h, Thread[tr][[hh /@ Range[nn]]], {2} ];
    ini = h[InitialStateList[M][[1]]];
    fin = Union[ h /@ FinalStateList[M] ];
    Q = Flatten@Position[equ,#]& /@ Range[nn]; 
    res = DFA[ TSys[ nn, k, nn k, tr, GetAlphabet[M], Type->Matrix], ini, fin ];       
    Switch[ norm, 
        Full, res, 
        Automatic, 
            SetStates[ res, Q ], 
        None, 
            SetStates[ res, StateList[M][[#]]& /@ Q ]
    ]
];


(* ::Subsection::Closed:: *)
(*ComplementFA*)


PackageSymbol[ComplementFA,
"ComplementFA[M]  generates a DFA that accepts the complement of the acceptance language of machine M."];


SyntaxInformation[ComplementFA] = {"ArgumentsPattern"->{_,_.,OptionsPattern[]}};
Options[ComplementFA]={};
AllOptions[ComplementFA]={};


ComplementFA[ M_DFA ] := 
    With[ {cmp = Complement[StateList[M],FinalStateList[M]]},
        ReplacePart[ M, -1->cmp ] ];

ComplementFA[ M_FA ] := ComplementFA[ DeterminizeFA[M] ];

ComplementFA[ M1_?FSMQ, M2_?FSMQ, opts:OptionsPattern[] ] := 
With[ {MM2 = ComplementFA[M2]},
     IntersectionFA[ M1, MM2, opts ]
];


(* ::Subsection::Closed:: *)
(*ConcatenateFA*)


PackageSymbol[ConcatenateFA,
"ConcatenateFA[M]  generates a DFA that accepts the complement of the acceptance language of machine M."];


SyntaxInformation[ConcatenateFA] = {"ArgumentsPattern"->{_,_.,OptionsPattern[]}};
Options[ConcatenateFA] = {EpsElim->True,Normalize:>$defaultnormalize};
AllOptions[ConcatenateFA]={};


ConcatenateFA[ M1_?FSMQ, M2_?FSMQ, M__?FSMQ, opts:OptionsPattern[] ] := 
    ConcatenateFA[ ConcatenateFA[ M1, M2, opts ], M, opts ]; 

ConcatenateFA[ M1_?FSMQ, M2_?FSMQ, opts:OptionsPattern[] ] := 
Module[ {k,n1,n2,Tmid,tr,res},
           k  = AlphabetCount[M1];
           n1 = StateCount[M1];
           n2 = StateCount[M2];
           Tmid = CartesianProduct[ FinalStateList[M1], {0}, InitialStateList[M2]+n1 ];
           tr   = Join[ TransitionList[M1], Tmid, 
                            MapTransitions[ TransitionList[M2], (#+n1&), Identity ] ];
           res  = FA[ TSys[ n1+n2, k, Length[tr],tr,GetAlphabet[M1]], 
                       InitialStateList[M1], FinalStateList[M2]+n1  ];
           If[ OptionValue[EpsElim], res = EpsilonEliminationFA[res] ];
           Switch[ OptionValue[Normalize], 
        	Full, res, 
        	Automatic,  
               SetStates[res,Join[{1,#}& /@ StateList[M1,Full->False], {2,#}& /@ StateList[M2,Full->False]]],
        	None,  
               SetStates[res,Join[{1,#}& /@ StateList[M1], {2,#}& /@ StateList[M2]]]
           ]
];


(* ::Subsection::Closed:: *)
(*StarFA*)


PackageSymbol[StarFA,
"StarFA[M]  generates a DFA that accepts the complement of the acceptance language of machine M."];


SyntaxInformation[StarFA] = {"ArgumentsPattern"->{_,_.,OptionsPattern[]}};
Options[StarFA] = {Normalize:>$defaultnormalize,EpsElim->True};
AllOptions[StarFA]={};


StarFA[ M_FA, opts:OptionsPattern[] ] := 
Module[ {n,k,T1,T2,tr,MM,res},
     k  = AlphabetCount[M];
     n  = StateCount[M];
     T1 = Map[ ({1,0,#})&, InitialStateList[M]+1 ];
     T2 = Map[ ({#,0,1})&, FinalStateList[M]+1 ];
     tr = Join[  MapTransitions[  TransitionList[M], (#+1&) ], T1, T2 ];
     res = FA[ TSys[ n+1, k, Length[tr], tr, GetAlphabet[M]], {1}, {1} ];
     If[ OptionValue[EpsElim], res = EpsilonEliminationFA[res] ];
     Switch[ OptionValue[Normalize],
		Full, res, 
        _,  SetStates[ res, Join[{n+1}, StateList[M]] ]
     ]
];
StarFA[ M_DFA, opts:OptionsPattern[]  ] := StarFA[ ToFA[M], opts  ];


(* ::Subsection::Closed:: *)
(*IntersectionFA*)


PackageSymbol[IntersectionFA,
"IntersectionFA[M1,M2]  generates the intersection automaton for M1 and M2."];


SyntaxInformation[IntersectionFA] = {"ArgumentsPattern"->{_,_,_.,OptionsPattern[]}};
Options[IntersectionFA]={Full->False,Type->"Intersection",Normalize:>$defaultnormalize};
AllOptions[IntersectionFA]={};


IntersectionFA[ M1_?FSMQ, M2_?FSMQ, opts:OptionsPattern[] ] := 
    ProductFA[ M1, M2, Type-> "Intersection", opts ];
IntersectionFA[ M1_?FSMQ, M2_?FSMQ, M___?FSMQ, opts:OptionsPattern[] ] := 
    IntersectionFA[ IntersectionFA[ M1, M2, opts ], M, opts ];


(* ::Subsection::Closed:: *)
(*ProductFA*)


(* ::Text:: *)
(*Does not handle normalization.*)


PackageSymbol[ProductFA,
"ProductFA[M1,M2]  generates the product automaton for M1 and M2."];


SyntaxInformation[ProductFA] = {"ArgumentsPattern"->{_,_,_.,OptionsPattern[]}};
Options[ProductFA]={Full->False,Normalize:>$defaultnormalize,Type->"Intersection"};
AllOptions[ProductFA]={};


ProductFA[M1_DFA,M2_DFA,opts:OptionsPattern[]] :=
Module[ {T1,T2,TT,ini,fin,Q,res,n,k,mat},
      T1 = TransitionSystem[M1];
      T2 = TransitionSystem[M2];
      If[ OptionValue[Full],  (* full quadratic transition system *) 
          TT = ProductTransitionSystem[T1,T2],
          TT = ProductTransitionSystem[T1,T2,{{InitialState[M1],InitialState[M2]}}]
      ];
      Q = StateList[TT];
      n = StateCount[TT];
      k = AlphabetCount[M1];
      mat = TransitionMatrix[ n, k, TransitionList[TT], Type->DFA ];
      TT = TSys[ n, k, n k, mat, GetAlphabet[M1], Type->Matrix ];
      ini = PositionOne[ Q, {InitialState[M1],InitialState[M2]} ];
      fin = Switch[  OptionValue[Type],
          "Intersection",
             PositionList[ Q, CartesianProduct[FinalStateList[M1],FinalStateList[M2]] ],
          "Union",
             PositionList[ Q, Join[ 
                    CartesianProduct[StateList[M1,Full->True],FinalStateList[M2]],
                    CartesianProduct[FinalStateList[M1],StateList[M2,Full->True]] ] ],
          "Complement",
             PositionList[ Q, CartesianProduct[FinalStateList[M1],
                       Complement[ StateList[M2,Full->True],FinalStateList[M2]] ] ]
      ];
      res = DFA[ TT, ini, fin ]
];

ProductFA[ M1_?FSMQ, M2_?FSMQ, opts:OptionsPattern[] ] := 
Module[ {T1,T2,TT,ini,fin,Q,res},
      T1 = TransitionSystem[M1];
      T2 = TransitionSystem[M2];
      If[ OptionValue[Full],  (* full quadratic transition system *) 
          TT = ProductTransitionSystem[T1,T2],
          TT = ProductTransitionSystem[T1,T2, CartesianProduct[InitialStateList[M1],InitialStateList[M2]]]
       ];
      Q = StateList[TT];
      ini = PositionList[ Q, CartesianProduct[InitialStateList[M1],InitialStateList[M2]] ];
      fin = PositionList[ Q, CartesianProduct[FinalStateList[M1],FinalStateList[M2]] ];

      res = FA[ TT, ini, fin ];
      ToAllFA[res]
];

ProductFA[ M1_?FSMQ, M2_?FSMQ, M___?FSMQ, opts:OptionsPattern[] ] := 
        ProductFA[ ProductFA[ M1, M2, opts ], M, opts ];


(*Options[productDFA] = {Full-> False,Normalize:> $defaultnormalize};
productDFA[ M1_DFA, M2_DFA, bool_, opts:OptionsPattern[]  ] := 
    Module[  { k, K, n, F, Ini, Q, Q1, Q2, Tr, A, A1, A2, 
             states, newstates, next, current, norm, full,rules,res},
           norm = Normalize /. {opts} /. Options[productDFA];
           full = Full /. {opts} /. Options[unionFA];
           If[ full, Return[ fullproductDFA[M1,M2,bool,norm] ] ];
           k =AlphabetSize[M1];
           A1 = Thread[Transitions[M1]];
           A2 = Thread[Transitions[M2]];
           states = {{TheInitial[M1],TheInitial[M2]}};
           next[{p_,q_}] :=
        ( 
          	t0 = Thread[{A1[[p]],A2[[q]]} ];
          	t  = Thread[ {Table[{p,q},{k}], Range[k], t0} ];
          	Tr = Join[ Tr, t ];
          	newstates = Union[ Select[t0,!MemberQ[states,#]&] ];
          	states = Join[states,newstates]  
          );
           Tr = {};
           current = 0;
           While[ current < Length[states],
                    P = states[[++current]];
                    next[ P ]
             ];
           Q   = Union@FlattenOne[ Drop[#,{2}]& /@ Tr ];
           n   = Length[Q];
           rules = RankingRules[ Q ];
           Tr  = Tr /. rules;
           A   = TransitionMatrix[ n, k, Tr,Type->DFA ];
           Ini = {TheInitial[M1],TheInitial[M2]} /. rules;
           If[ bool,
                 F = Select[ states, 
                         (MemberQ[Final[M1],#[[1]]] || 
                  MemberQ[Final[M2],#[[2]]])& ],
                 F = Select[ states, 
                         (MemberQ[Final[M1],#[[1]]] && 
                  MemberQ[Final[M2],#[[2]]])& ]      
             ];
           res = DFA[ n, ShortAlphabetSize[M1], A, Ini, Union[F /. rules], 
          		ShortAlphabet[M1], {} ];
           Switch[ norm,
                 0, res,
                 1, ReplacePart[ res, Q, -1 ],
                 2, 
        ReplacePart[ 
          res, {States[M1][[#[[1]]]],States[M2][[#[[2]]]]}& /@ Q, -1 ]  
             ]
      ];
fullproductDFA[ M1_DFA, M2_DFA, bool_, norm_ ] := 
    Module[ {k,F,Ini,rules,cp,T1,T2,Tr,A,n,n1,n2,res},
           k =AlphabetSize[M1];
           n1  = Size[ M1 ];
           n2  = Size[ M2 ];
           n   = n1 n2;
           cp  = CartesianProduct[ n1, n2 ];
           rules = RankingRules[ cp ];
           T1  = MatrixToTransitions[M1];
           T2  = MatrixToTransitions[M2];
           Tr  = ProductTransitions[ T1, T2, k ];     
           Tr  = Tr /. rules;
           A   = TransitionMatrix[ n, k, Tr,Type->DFA ];
           Ini = {TheInitial[M1],TheInitial[M2]} /. rules;
           If[ bool,
                 F = Join[ CartesianProduct[Range[n1],Final[M2]], 
                               CartesianProduct[Final[M1],Range[n2]] ],
                 F = CartesianProduct[Final[M1],Final[M2]] 
             ];
           res = DFA[ n, ShortAlphabetSize[M1], A, Ini, Union[F /. rules], 
          		ShortAlphabet[M1], {} ];
           Switch[ norm, 
        	0, res, 
        	1, ReplacePart[ res, cp, -1 ],
        	2, 
        ReplacePart[ 
          res, {States[M1][[#[[1]]]],States[M2][[#[[2]]]]}& /@ cp, -1 ]
             ]
      ];*)



(* ::Subsection::Closed:: *)
(*UnionFA*)


(* ::Text:: *)
(*Does not handle normalization.*)


PackageSymbol[UnionFA,
"UnionFA[M1,M2]  generates the sum automaton for M1 and M2."];


SyntaxInformation[UnionFA] = {"ArgumentsPattern"->{_,_,_.,OptionsPattern[]}};
Options[UnionFA]={Full->False,Normalize:>$defaultnormalize,Type->"Intersection"};
AllOptions[UnionFA]={};


UnionFA[M1_DFA,M2_DFA,opts:OptionsPattern[]] := $Failed;


UnionFA[ M1_?FSMQ, M2_?FSMQ, opts:OptionsPattern[] ] := 
Module[ {n1,n2,T1,T2,A,k,ini,fin,Q,res},
	  n1 = StateCount[M1];
	  n2 = StateCount[M2];
	  A = GetAlphabet[M1];
	  Assert[ A === GetAlphabet[M2] ];
	  k = AlphabetCount[A];
      T1 = TransitionList[M1];
      T2 = (#+{n1,0,n1})& /@ TransitionList[M2];
      ini = Join[InitialStateList[M1], n1+ InitialStateList[M2] ];
      fin = Join[FinalStateList[M1],n1 + FinalStateList[M2]];
      res = FA[ TSys[n1+n2,k,Length[T1]+Length[T2],Join[T1,T2],A], ini, fin ]
      ];

UnionFA[ M1_?FSMQ, M2_?FSMQ, M___?FSMQ, opts:OptionsPattern[] ] := 
        UnionFA[ UnionFA[ M1, M2, opts ], M, opts ];


(*Options[productDFA] = {Full-> False,Normalize:> $defaultnormalize};
productDFA[ M1_DFA, M2_DFA, bool_, opts:OptionsPattern[]  ] := 
    Module[  { k, K, n, F, Ini, Q, Q1, Q2, Tr, A, A1, A2, 
             states, newstates, next, current, norm, full,rules,res},
           norm = Normalize /. {opts} /. Options[productDFA];
           full = Full /. {opts} /. Options[unionFA];
           If[ full, Return[ fullproductDFA[M1,M2,bool,norm] ] ];
           k =AlphabetSize[M1];
           A1 = Thread[Transitions[M1]];
           A2 = Thread[Transitions[M2]];
           states = {{TheInitial[M1],TheInitial[M2]}};
           next[{p_,q_}] :=
        ( 
          	t0 = Thread[{A1[[p]],A2[[q]]} ];
          	t  = Thread[ {Table[{p,q},{k}], Range[k], t0} ];
          	Tr = Join[ Tr, t ];
          	newstates = Union[ Select[t0,!MemberQ[states,#]&] ];
          	states = Join[states,newstates]  
          );
           Tr = {};
           current = 0;
           While[ current < Length[states],
                    P = states[[++current]];
                    next[ P ]
             ];
           Q   = Union@FlattenOne[ Drop[#,{2}]& /@ Tr ];
           n   = Length[Q];
           rules = RankingRules[ Q ];
           Tr  = Tr /. rules;
           A   = TransitionMatrix[ n, k, Tr,Type->DFA ];
           Ini = {TheInitial[M1],TheInitial[M2]} /. rules;
           If[ bool,
                 F = Select[ states, 
                         (MemberQ[Final[M1],#[[1]]] || 
                  MemberQ[Final[M2],#[[2]]])& ],
                 F = Select[ states, 
                         (MemberQ[Final[M1],#[[1]]] && 
                  MemberQ[Final[M2],#[[2]]])& ]      
             ];
           res = DFA[ n, ShortAlphabetSize[M1], A, Ini, Union[F /. rules], 
          		ShortAlphabet[M1], {} ];
           Switch[ norm,
                 0, res,
                 1, ReplacePart[ res, Q, -1 ],
                 2, 
        ReplacePart[ 
          res, {States[M1][[#[[1]]]],States[M2][[#[[2]]]]}& /@ Q, -1 ]  
             ]
      ];
fullproductDFA[ M1_DFA, M2_DFA, bool_, norm_ ] := 
    Module[ {k,F,Ini,rules,cp,T1,T2,Tr,A,n,n1,n2,res},
           k =AlphabetSize[M1];
           n1  = Size[ M1 ];
           n2  = Size[ M2 ];
           n   = n1 n2;
           cp  = CartesianProduct[ n1, n2 ];
           rules = RankingRules[ cp ];
           T1  = MatrixToTransitions[M1];
           T2  = MatrixToTransitions[M2];
           Tr  = ProductTransitions[ T1, T2, k ];     
           Tr  = Tr /. rules;
           A   = TransitionMatrix[ n, k, Tr,Type->DFA ];
           Ini = {TheInitial[M1],TheInitial[M2]} /. rules;
           If[ bool,
                 F = Join[ CartesianProduct[Range[n1],Final[M2]], 
                               CartesianProduct[Final[M1],Range[n2]] ],
                 F = CartesianProduct[Final[M1],Final[M2]] 
             ];
           res = DFA[ n, ShortAlphabetSize[M1], A, Ini, Union[F /. rules], 
          		ShortAlphabet[M1], {} ];
           Switch[ norm, 
        	0, res, 
        	1, ReplacePart[ res, cp, -1 ],
        	2, 
        ReplacePart[ 
          res, {States[M1][[#[[1]]]],States[M2][[#[[2]]]]}& /@ cp, -1 ]
             ]
      ];*)



(* ::Subsection::Closed:: *)
(*ShuffleProductFA*)


PackageSymbol[ShuffleProductFA,
"ShuffleProductFA[M1,M2,opts]  generates the shuffle product automaton for M1 and M2."];


SyntaxInformation[ShuffleProductFA] = {"ArgumentsPattern"->{_,_,_.,OptionsPattern[]}};
Options[ShuffleProductFA]={Normalize:>$defaultnormalize};
AllOptions[ShuffleProductFA]={};


ShuffleProductFA[ M1_?FSMQ, M2_?FSMQ, opts:OptionsPattern[] ] := 
Module[  {MM1,MM2,n1,n2,F,Ini,rules,nn,Tr,Q,T1,T2,res},
     k =   AlphabetCount[M1];
     MM1 = ToFA[M1];
     MM2 = ToFA[M2];    
     n1  = StateCount[MM1];
     n2  = StateCount[MM2];
     T1  = TransitionList[MM1];
     T2  = TransitionList[MM2];
     Tr  = shuffleProductTransitions[n1,n2,T1,T2];    
     Q   = Union[ Flatten[ Drop[#,{2}]& /@ Tr, 1 ] ];
     rules = RankingRules[Q];
     Tr  = Tr /. rules;
     Ini = CartesianProduct[ InitialStateList[MM1],InitialStateList[MM2] ] /. rules;
     F   = CartesianProduct[ FinalStateList[MM1], FinalStateList[MM2] ] /. rules;
     res = FA[ TSys[ Length[Q], k, Length[Tr],Tr, GetAlphabet[M1]], Sort[Ini], Sort[F] ];
     Switch[ OptionValue[Normalize],
         Full, res,
         1, SetStates[ res, Q ],
         2, SetStates[ res, {StateList[M1][[#[[1]]]],StateList[M2][[#[[2]]]]}& /@ Q ] 
     ]
];

shuffleProductTransitions[ n1_Integer, n2_Integer, L1_List, L2_List ] := 
Module[ {prod1,prod2},  
    prod1[{x_,a_,y_}] := {{x,#},a,{y,#}}& /@ Range[n2];
    prod2[{x_,a_,y_}] := {{#,x},a,{#,y}}& /@ Range[n1];
    Union[ Flatten[ prod1 /@ L1, 1 ], Flatten[ prod2 /@ L2, 1 ] ]
];


(* ::Subsection::Closed:: *)
(*GrowthFunctionDFA*)


PackageSymbol[GrowthFunctionDFA,
"GrowthSeriesDFA[M,x] returns a generating function for the growth function of M."];


SyntaxInformation[GrowthFunctionDFA] = {"ArgumentsPattern"->{_,_,OptionsPattern[]}};
Options[GrowthFunctionDFA]={Full->False};
AllOptions[GrowthFunctionDFA]={};


GrowthFunctionDFA[M_DFA,x_,opts:OptionsPattern[]]:=
Module[{nn,A,gfs,res},
	nn = StateCount[M];
	A  = Total@Normal@TransitionToBooleanMatrix[M];
	gfs = LinearSolve[  IdentityMatrix[nn] - A x,
			ToBitVector[ FinalStateList[M], Range[nn] ], SelectOptions[LinearSolve,opts]];
	res = Simplify[ gfs[[ InitialState[M] ]] ];
	If[  OptionValue[Full], 
		{res,gfs},
		res 
	]
];


(* ::Section::Closed:: *)
(*Decisions*)


(* ::Subsection::Closed:: *)
(*TestPropertyFA*)


PackageSymbol[TestPropertyFA,
"TestPropertyFA[A,P,opts] tests automaton A for property P."];


SyntaxInformation[TestPropertyFA] = {"ArgumentsPattern"->{_.,_.,OptionsPattern[]}};
Attributes[TestPropertyFA]={};
Options[TestPropertyFA]={Type->"Deterministic",Full->False};
AllOptions[TestPropertyFA]={};


TestPropertyFA::noprp="Property `1` is undefined in TestPropertyFA.";
TestPropertyFA[ ] :={"Accessible","Coaccessible","Trim","Deterministic","Codeterministic",
"Complete","Ambiguous","Definite","Finite"};
TestPropertyFA[ M_?FSMQ, props:{__String}, opts:OptionsPattern[] ] :=
	TestPropertyFA[ M, #, opts ]& /@ props;
TestPropertyFA[ M_?FSMQ, prop_String, opts:OptionsPattern[] ] :=
Switch[  prop, 
	"Accessible",  auxAccessibleQ[M, SelectOptions[auxAccessibleQ,opts]],
	"Ambiguous",  auxAmbiguousQ[M, SelectOptions[auxAmbiguousQ,opts]],
	"Deterministic",  auxDeterministicQ[M, SelectOptions[auxDeterministicQ,opts]],
	"Codeterministic",  auxCodeterministicQ[M, SelectOptions[auxCodeterministicQ,opts]],
	"Complete",  auxCompleteQ[M, SelectOptions[auxCompleteQ,opts]],
	"Definite", auxDefiniteQ[M, SelectOptions[auxDefiniteQ,opts]],
	"Coaccessible",  auxCoaccessibleQ[M, SelectOptions[auxCoaccessibleQ,opts]],
	"Trim",  auxTrimQ[M, SelectOptions[auxTrimQ,opts]],
	"Finite",  auxFiniteQ[M, SelectOptions[auxFiniteQ,opts]],
	_, Message[TestPropertyFA::noprp,type ] 
];

Options[auxAccessibleQ]={Full->False};
auxAccessibleQ[M_?FSMQ,opts:OptionsPattern[]]:=
Module[ {G,Q,tf},
	G = TransitionsToGraph[M];
	Q = VertexOutComponent[ G, InitialStateList[M] ];
	tf = Length[Q] == StateCount[M];
	If[ OptionValue[Full],
		{tf,Q},
		tf
	]
];

Options[auxAmbiguousQ]={};     (* should arguable produce witness *)
auxAmbiguousQ[M_?FSMQ]:=
Module[ {T,MM,diag,G,H,scc,ntscc,di,nd,R},
	If[ TestPropertyFA[M,"Deterministic"]||TestPropertyFA[M,"Codeterministic"],
			Return[False]];
	MM = With[{ts=TransitionSystem[M]}, 
	ProductTransitionSystem[ts,ts] ];
	Attributes[diag]={Listable};
	Scan[ (diag[#]=1)&,Flatten@Position[StateList[MM],{p_,p_}] ];
	diag[_] := 0;
	G = TransitionsToGraph[ MM ];
	{H,scc,ntscc} = CondensationGraph[G,Full->True];
	If[ Select[ scc, Union[diag[#]]==={0,1}& ]=!={}, Return[True] ];
	di = Select[ scc, Union[diag[#]]==={1}& ];
	nd = Select[ scc, Union[diag[#]]==={0}& ];
	Do[ 
		R = Intersection[ VertexOutComponent[H,{v}], di ];
		If[ Intersection[ VertexOutComponent[H,R], nd ]=!={},
		Return[True] ],
	{v,nd}
	];
	False
];

Options[auxCoaccessibleQ]={Full->False};
auxCoaccessibleQ[M_?FSMQ,opts:OptionsPattern[]]:=
	auxAccessibleQ[ ReverseFA[M], opts ];
Options[auxAmbiguousQ]={Full->False};
auxAmbiguousQ[MM_?FSMQ,opts:OptionsPattern[]]:=
Module[ {M,M2,Qdiag,G,Qf,Qb,tf},
	M = TrimFA[MM];
	M2 = ProductFA[M,M];
	Qdiag = Flatten[Position[ StateList[M2],{x_,x_}]];
	G = TransitionsToGraph[M2];
	Qf = VertexOutComponent[G,Intersection[InitialStateList[M2],Qdiag]];
	Qb = VertexOutComponent[ReverseGraph[G],Intersection[FinalStateList[M2],Qdiag]];
	tf = Intersection[ Qf,Qb]===Sort[Qdiag];
	If[ OptionValue[Full],
		{tf,{G,Intersection[ Qf,Qb],Qdiag}},
		tf
	]
];
Options[auxCoaccessibleQ]={Full->False};
auxCoaccessibleQ[M_?FSMQ,opts:OptionsPattern[]]:=
Module[ {G,Q,tf},
	G = ReverseGraph[TransitionsToGraph[M]];
	Q = VertexOutComponent[ G, FinalStateList[M] ];
	tf = Length[Q] == StateCount[M];
	If[ OptionValue[Full],
		{tf,Q},
		tf
	]
];
Options[auxTrimQ]={Full->False};
auxTrimQ[M_?FSMQ,opts:OptionsPattern[]]:=
Module[ {G,Qf,Qb,Q,tf},
	G = TransitionsToGraph[M];
	Qf = VertexOutComponent[ G, InitialStateList[M] ];
	Qb = VertexOutComponent[ ReverseGraph[G],FinalStateList[M] ];	
	Q = Intersection[Qf,Qb];
	tf = Length[Q] == StateCount[M];
	If[ OptionValue[Full],
		{tf,Q},
		tf
	]
];
Options[auxCompleteQ]={Full->False};
auxCompleteQ[M_DFA,opts:OptionsPattern[]]:= True;
auxCompleteQ[M_?FSMQ,opts:OptionsPattern[]]:=
Module[ {tr,tf},
	tr = Union[Drop[#,-1]&/@ TransitionList[M]];
	tf = Length[tr] == StateCount[M] AlphabetCount[M];
	If[ OptionValue[Full],
		{tf,Complement[ CartesianProduct[ StateCount[M], AlphabetCount[M]],tr ]},
		tf
	]
];
	 
Options[auxDeterministicQ]={Full->False};
auxDeterministicQ[M_DFA,opts:OptionsPattern[]]:= True;
auxDeterministicQ[M_?FSMQ,opts:OptionsPattern[]]:=
Module[{tr,tf},
	tr = GatherBy[  TransitionList[M],Drop[#,-1]&];
	tf = AllTrue[tr,Length[#]==1& ];
	If[  OptionValue[Full],
		{tf,Select[tr,Length[#]>1& ]},
		tf
	]
];
Options[auxCodeterministicQ]={Full->False};
auxCodeterministicQ[M_?FSMQ,opts:OptionsPattern[]]:=
Module[{tr,tf},
	tr = GatherBy[  TransitionList[M],Drop[#,1]&];
	tf = AllTrue[tr,Length[#]==1& ];
	If[  OptionValue[Full],
		{tf,Select[tr,Length[#]>1& ]},
		tf
	]
];

Options[auxDefiniteQ]={Full->False};
auxDefiniteQ[MM_DFA,opts:OptionsPattern[]]:=
Module[{M,M2,G,H,scc,ntscc,tf,defn},
	M=MM;
	Assert[ TestPropertyFA[M,"Accessible"] ];
	SetInitialFinalFA[M,All,All];
	M2 = ProductFA[M,M];
	G = TransitionsToGraph[M2];
	{H,scc,ntscc} = CondensationGraph[G,Full->True];
	tf = Length[ntscc]==1;
	If[ OptionValue[Full],
	defn = Max[ Table[ GraphDistance[H,u,scc[[ntscc[[1]]]]], {u,VertexList[H]}]];
	{tf,defn },
	tf
	]
];

Options[auxFiniteQ]={};
auxFiniteQ[M_?FSMQ,opts:OptionsPattern[]]:=
	AcyclicGraphQ[ TransitionsToGraph[ TrimFA[M] ] ];


(* ::Subsection::Closed:: *)
(*EmptyQFA*)


PackageSymbol[EmptyQFA,
"EmptyQFA[M] checks whether the language of M is empty."];


SyntaxInformation[EmptyQFA] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Attributes[EmptyQFA]={Listable};
Options[EmptyQFA]={};
AllOptions[EmptyQFA]={};


EmptyQFA[M_?FSMQ] := 
With[{Q = TrimStateList[M,Type->Accessible]},
	 Intersection[ Q, FinalStateList[M]] === {}
];


(* ::Subsection::Closed:: *)
(*FiniteQFA*)


PackageSymbol[FiniteQFA,
"FiniteQFA[M] checks whether the language of M is finite."];


SyntaxInformation[FiniteQFA] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Attributes[FiniteQFA]={Listable};
Options[FiniteQFA]={};
AllOptions[FiniteQFA]={};


FiniteQFA[M_?FSMQ] := 
With[{G = TransitionsToGraph[ TrimFA[M] ]},
	Select[ ConnectedComponents[G], NonTrivialComponentQ[G,#]& ]==={}
];


(* ::Subsection::Closed:: *)
(*DeterministicQFA    **KILL***)


(* ::Text:: *)
(*see TestPropertyFA*)


(*PackageSymbol[DeterministicQFA,
"DeterministicQFA[M] checks whether eps-free automaton M is deterministic."];*)


(*SyntaxInformation[DeterministicQFA] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Attributes[DeterministicQFA]={Listable};
Options[DeterministicQFA]={Direction->Forward};
AllOptions[DeterministicQFA]={};*)


(*DeterministicQFA[T_TSys,opts:OptionsPattern[] ] := 
Module[ {tr},
    tr = TransitionList[T];
    If[ OptionValue[Direction] == Backward, 
         tr = Reverse /@ tr ];
    Max[ Length/@ GatherBy[ tr, Take[#,2]& ] ] == 1
];
DeterministicQFA[M_?FSMQ,opts:OptionsPattern[] ] := 
	DeterministicQFA[TransitionSystem[M],opts];*)


(* ::Subsection::Closed:: *)
(*DefiniteQDFA    **KILL***)


(* ::Text:: *)
(*see TestPropertyFA*)


(*PackageSymbol[DefiniteQDFA,
"DefiniteQDFA[M] checks whether the language of M is definite."];*)


(*SyntaxInformation[DefiniteQDFA] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Attributes[DefiniteQDFA]={Listable};
Options[DefiniteQDFA]={};
AllOptions[DefiniteQDFA]={};*)


(*DefiniteQDFA[M_DFA] := 
Module[ {T,G},
	T = TransitionSystem[ M ];
	T = ProductTransitionSystem[ T, T ];
	G = TransitionsToGraph[ T ];
	Length@Select[ ConnectedComponents[G], NonTrivialComponentQ[G,#]& ] == 1
];*)


(* ::Subsection::Closed:: *)
(*UniversalQFA*)


PackageSymbol[UniversalQFA,
"UniversalQFA[M] checks whether the language of M is universal."];


SyntaxInformation[UniversalQFA] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Attributes[UniversalQFA]={Listable};
Options[UniversalQFA]={};
AllOptions[UniversalQFA]={};


UniversalQFA[M_FA] := UniversalQFA[ DeterminizeFA[M] ];
UniversalQFA[M_DFA] := 
With[{MM = TrimFA[M,Type->Accessible]},
	TrapStateList[MM,Full->False]==={}
];


(* ::Subsection::Closed:: *)
(*EquivalentQFA*)


(* ::Text:: *)
(*fake union/find, needs ranking and path compression*)
(*note bound 5000 on fixed points*)


PackageSymbol[EquivalentQFA,
"EquivalentQFA[M1,M2] checks whether automata M1 and M2 are equivalent."];


SyntaxInformation[EquivalentQFA] = {"ArgumentsPattern"->{_,_,OptionsPattern[]}};
Attributes[EquivalentQFA]={};
Options[EquivalentQFA]={DoTrace->False};
AllOptions[EquivalentQFA]={};
EquivalentQFA::badalph = "Alphabets differ.";


EquivalentQFA[ M1_DFA, M2_DFA, opts:OptionsPattern[] ] := 
(
     With[ {res = equivalentUnionFind[ M1, M2 ]},
      If[ OptionValue[DoTrace], res, First[res] ] ]
);

EquivalentQFA[ M1_?FSMQ, M2_?FSMQ, opts:OptionsPattern[] ] := 
(
    If[ GetAlphabet[M1]=!=GetAlphabet[M2], 
        Message[EquivalentQFA::badalph];  
        Return[$Failed]
    ]; 
    With[ {res = equivalentUnionFind[ DeterminizeFA[M1], DeterminizeFA[M2], opts ]},
      If[ OptionValue[DoTrace], res, First[res] ] ]
);

equivalentUnionFind[ M1_DFA, M2_DFA ] := 
Module[ {n1,n2,nn,K,FF,act,p,q,r1,r2,uf,L,del1,del2,part,res},
      	n1 = StateCount[M1];
      	n2 = StateCount[M2];
      	nn = n1 + n2;
      	K  = Range[AlphabetCount[M1]];
      	FF = Join[ FinalStateList[M1], FinalStateList[M2] + n1 ];
      	AssignFunction[ uf, Range[nn], Range[nn] ];
      	AssignTransitionFunction[ del1, M1 ];
      	AssignTransitionFunction[ del2, M2 ];
      	act = {{InitialState[M1],InitialState[M2]}};
      	While[ act =!= {},
        		{p,q} = First[act];
        		act = Rest[act];  
        		r1 = FixedPoint[ uf, p, 5000 ];
        		r2 = FixedPoint[ uf, q+n1, 5000 ];
        		If[ r1 != r2, 
          			uf[r2] = r1;
          			Scan[  AppendTo[ act, Flatten[{del1[p,#],del2[q,#]}]]&, K ];
          	  ];
        	];
      	L = FixedPoint[uf,#,5000]& /@ Range[nn]; 
      	part = ToClasses[ Range[nn], L, Type->Index]; 
          res = AllTrue[  part, Intersection[FF,#]==={} || SubsetQ[FF,#]& ];
          {res,part}
];


(* ::Subsection::Closed:: *)
(*IsomorphicQDFA*)


(* ::Text:: *)
(*alas, labeled digraphs*)


PackageSymbol[IsomorphicQDFA,
"IsomorphicQDFA[M1,M2] checks whether the DFAs M1 and M2 are isomorphic."];


SyntaxInformation[IsomorphicQDFA] = {"ArgumentsPattern"->{_,_,OptionsPattern[]}};
Attributes[IsomorphicQDFA]={};
Options[IsomorphicQDFA]={DoTrace->False};
AllOptions[IsomorphicQDFA]={};


IsomorphicQDFA[ M1_DFA, M2_DFA, opts:OptionsPattern[] ] :=
    Module[ {res,iso},
     If[ StateCount[M1] != StateCount[M2], Return[False] ];
     If[ AlphabetCount[M1] != AlphabetCount[M2], Return[False] ];
     If[ Length[FinalStateList[M1]] != Length[FinalStateList[M2]], Return[False] ];
     {res,iso} = CoverQDFA[ M1, M2, DoTrace->True ];
     If[ OptionValue[DoTrace], 
        {res,iso},
        res
     ]
];


(* ::Subsection::Closed:: *)
(*CoverQDFA*)


(* ::Text:: *)
(*fake union/find, needs ranking and path compression*)


PackageSymbol[CoverQDFA,
"CoverQDFA[M1,M2,opts] checks whetherthe DFAs M1 and M2 are isomorphic."];


SyntaxInformation[CoverQDFA] = {"ArgumentsPattern"->{_,_,OptionsPattern[]}};
Attributes[CoverQDFA]={};
Options[CoverQDFA]={DoTrace->False};
AllOptions[CoverQDFA]={};


CoverQDFA[ M1_DFA, M2_DFA, opts:OptionsPattern[] ] :=
    Module[ { n1, n2, h, dom, rng, prefin2, cover },
           n1 = StateCount[M1];
           n2 = StateCount[M2];
           
           (* check if a covering map h exists *)
           If[ !AssignHomomorphismDFA[ h, M1, M2 ], Return[{False,{}}] ];
           (* test h for surjectivity and compatibility with final states  *)
           dom = Select[ Range[n1], (h[#] > 0)& ];
           rng = Union[ h[dom] ];
           If[ Length[ rng ] < n2, Return[{False,{}}] ];
           prefin2 = Select[ dom, (MemberQ[ FinalStateList[M2], h[#] ])& ];
           cover = Sort[ Intersection[FinalStateList[M1],dom] ] === Sort[ prefin2 ];
           If[ OptionValue[DoTrace], 
               {cover, Thread[{StateList[M1][[dom]], StateList[M2][[h[dom]]]}]},
               {cover,{}}
           ]
      ];


(* ::Subsection::Closed:: *)
(*AssignHomomorphismDFA*)


(* ::Text:: *)
(*Can this use DepthFirstScan? *)


PackageSymbol[AssignHomomorphismDFA,
"AssignHomomorphismDFA[M1,M2] tries to construct a homomorphism from DFA M1 to DFA M2."];


SyntaxInformation[AssignHomomorphismDFA] = {"ArgumentsPattern"->{_,_,_,OptionsPattern[]}};
Attributes[AssignHomomorphismDFA]={HoldFirst};
Options[AssignHomomorphismDFA]={};
AllOptions[AssignHomomorphismDFA]={};


AssignHomomorphismDFA[ h_, M1_DFA, M2_DFA ] :=
    Module[ { A1, A2, dfs, dfsact, homo },
          ClearAll[h];
          SetAttributes[h,Listable];
          SetAttributes[dfsact,Listable];
          A1 = Thread[TransitionsRaw[M1]]; 
          A2 = Thread[TransitionsRaw[M2]]; 
          homo = True;
          (* initialize h array to 0 *)
          h[_]=0;
          (* run DFS in M1 and M2 in parallel *)
          dfs[ x_Integer ] := dfsact[ A1[[x]], A2[[h[x]]] ];     
          (* explore successor delta[x,a] *)
          dfsact[ p_, q_ ] := 
                If[ h[p] == 0, 
                      h[p] = q; dfs[p],
                      If[ h[p] != q, homo = False ]
                  ];
          (*  perform exploration  *)
          h[InitialState[M1]] = InitialState[M2];
          dfs[ InitialState[M1] ];
          homo
   ];


(* ::Section::Closed:: *)
(*Regular Expressions*)


PackageSymbol[$regexrules,
"$regexrules is a collection of rewrite rules for regular expressions."];


(* ::Subsection:: *)
(*BEFA*)


(* ::Subsection:: *)
(*Glushkov*)


(* ::Section::Closed:: *)
(*Syntactic Semigroups*)


(* ::Subsection::Closed:: *)
(*SGT*)


(* ::Text:: *)
(*A header for transformations:  SGT[{Subscript[a, 1],Subscript[a, 2],\[Ellipsis],Subscript[a, n]}]    1 <= Subscript[a, i]<= n*)


PackageSymbol[SGT,
"SGT[L] denotes the transformation given by list L."];


SyntaxInformation[SGT] = {"ArgumentsPattern"->{_}};
Options[SGT]={};
AllOptions[SGT]={};


Unprotect[NonCommutativeMultiply];
SetAttributes[NonCommutativeMultiply,Listable];
Protect[NonCommutativeMultiply];
x_SGT ** y_SGT ^:= SemigroupProduct[x,y]
x_SGT ** y_SGT ** zz__SGT ^:= SemigroupProduct[x,y,zz];
x_SGT^k_  ^:= SemigroupPower[x,k];


(* ::Subsection::Closed:: *)
(*SemigroupDegree*)


PackageSymbol[SemigroupDegree,
"SemigroupDegree[T] returns the degree of a transformation T."];


SyntaxInformation[SemigroupDegree] = {"ArgumentsPattern"->{_}};
Options[SemigroupDegree]={};
AllOptions[SemigroupDegree]={};


SemigroupDegree[M_DFA] :=SemigroupDegree[ToTransformationsDFA[M]];
SemigroupDegree[SGT[x_List]]:= Length[x];
SemigroupDegree[L_List] := SemigroupDegree[First[L]];


(* ::Subsection::Closed:: *)
(*SemigroupProduct*)


(* ::Text:: *)
(*diagrammatic composition*)


PackageSymbol[SemigroupProduct,
"SemigroupProduct[x,y] computes the product of transformations x and y."];


SyntaxInformation[SemigroupProduct] = {"ArgumentsPattern"->{__}};
Options[SemigroupProduct]={};
AllOptions[SemigroupProduct]={};


SemigroupProduct[ T_SGT ] := T;
SemigroupProduct[ SGT[{x__}], SGT[{y__}] ]:= SGT[{y}[[{x}]]];
SemigroupProduct[ SGT[{x__}], SGT[{y__}], tt__SGT ]:= SemigroupProduct[ SGT[{y}[[{x}]]], tt ];
SemigroupProduct[ L:{__SGT}, y_SGT ]:= SemigroupProduct[#,y]& /@ L;
SemigroupProduct[ x_SGT, L:{__SGT} ]:= SemigroupProduct[x,#]& /@ L;
SemigroupProduct[ L:{__SGT}, K:{__SGT} ]:= SemigroupProduct@@@CartesianProduct[L,K];
SemigroupProduct[ x_, y_ , zz__ ]:= SemigroupProduct[SemigroupProduct[x,y],zz];


(* ::Subsection::Closed:: *)
(*SemigroupPower*)


(* ::Text:: *)
(*diagrammatic composition*)


PackageSymbol[SemigroupPower,
"SemigroupPower[T,k] computes T^k for a transformation T."];


SyntaxInformation[SemigroupPower] = {"ArgumentsPattern"->{_,_}};
Options[SemigroupPower]={};
AllOptions[SemigroupPower]={};


SemigroupPower[T_SGT,k_Integer?NonNegative] := auxFastExpoSGT[T,k];

auxFastExpoSGT[x_SGT,0]:=SGT[Range[Length[x[[1]]]]];
auxFastExpoSGT[x_SGT,1]:=x;
auxFastExpoSGT[x_SGT,n_Integer?Positive]:=
Module[{fe},
	fe[1]=x;
	fe[m_Integer?Positive]:=fe[m]=fe[Floor[m/2]]**fe[Ceiling[m/2]];
	fe[n]
];


(* ::Subsection::Closed:: *)
(*TransformationQ*)


(* ::Text:: *)
(*{Subscript[a, 1], Subscript[a, 2], \[Ellipsis],Subscript[a, n]}    where 1 <= Subscript[a, i] <= n.*)


PackageSymbol[TransformationQ,
"TransformationQ[L] checks whether list L can be interpreted as a transformation."];


SyntaxInformation[TransformationQ] = {"ArgumentsPattern"->{_}};
Options[TransformationQ]={};
AllOptions[TransformationQ]={};


TransformationQ[L:{__Integer}] :=  SubsetQ[ Range[Length[L]], L ];
TransformationQ[_] := False;


(* ::Subsection::Closed:: *)
(*PermutationToTransformation*)


PackageSymbol[PermutationToTransformation,
"PermutationToTransformation[p,n] returns the rank n transformation corresponding to permutation p."];


SyntaxInformation[PermutationToTransformation] = {"ArgumentsPattern"->{_,_.,OptionsPattern[]}};
Options[CycleDecompositionSGT]={};
AllOptions[CycleDecompositionT]={};


PermutationToTransformation[p_Cycles,n_Integer] := 
	SGT[ PermutationList[p,n] ]    /;  n >= PermutationMax[p];
PermutationToTransformation[pp:{__Cycles},n_Integer] := 
	PermutationToTransformation[#,n]& /@ pp;
PermutationToTransformation[L_List] := 
	SGT[ L ]  /;  TransformationQ[L];


(* ::Subsection::Closed:: *)
(*ToTransformationsDFA*)


PackageSymbol[ToTransformationsDFA,
"ToTransformationsDFA[M] returns the transformations corresponding to DFA M."];


SyntaxInformation[ToTransformationsDFA] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[ToTransformationsDFA]={};
AllOptions[ToTransformationsDFA]={};


ToTransformationsDFA[M_DFA] := SGT/@Normal[TransitionsRaw[M]];


(* ::Subsection::Closed:: *)
(*GenerateSemigroup*)


(* ::Text:: *)
(*semigroup vs. monoid nuisance: Full->True does not eliminate phony 1*)


PackageSymbol[GenerateSemigroup,
"GenerateSemigroup[{t1,..,tk},opts] returns the semigroup generated by transformations t1,...,tk."];


SyntaxInformation[GenerateSemigroup] = {"ArgumentsPattern"->{_,OptionsPattern[]}};
Options[GenerateSemigroup]={Bound->10000,Full->False,Direction->Right,GreenRel->False};
AllOptions[GenerateSemigroup]={};


GenerateSemigroup[ gen:{__SGT}, opts:OptionsPattern[] ] := 
Module[{k,n,one,ops,res,S,edf,edb,W,G},

	If[ OptionValue[GreenRel], 
		Return[auxGenerateGreen[gen,SelectOptions[auxGenerateGreen,opts] ] ] ];
		
	k = Length[gen];
	n = Length[gen[[1,1]]];
	one = SGT[Range[n]];
	ops = If[ OptionValue[Direction]===Right,
		Quiet@Table[ Evaluate[SemigroupProduct[#,gen[[i]]]]&, {i,k} ],
		Quiet@Table[ Evaluate[SemigroupProduct[gen[[i]],#]]&, {i,k} ]
	];
	{S,edf,edb,W} = Closure[ one, ops, 
			Cayley->True, Witnesses->True, Full->True, Bound->OptionValue[Bound] ];

    If[ OptionValue[Full] || Cases[ edb, {_,_,1} ] =!= {}, 
        Return[{S,edf,edb,W}]];

    edf = DeleteCases[edf,{1,_,_}];
    edb = DeleteCases[edb,{_,_,1}];
    { Rest[S], MapTransitions[edf, (#-1&)], MapTransitions[edb, (#-1&)], Rest[W] }
];

GenerateSemigroup[ M_DFA, opts:OptionsPattern[] ] :=
    GenerateSemigroup[ ToTransformationsDFA[M], opts ];

GenerateSemigroup[ gen_TransformationSemigroup, opts:OptionsPattern[] ] := 
    GenerateSemigroup[ gen[[1]], opts ]; 
   
Options[auxGenerateGreen] = {Bound->10000}; 
auxGenerateGreen[ gen:{__SGT}, opts:OptionsPattern[] ] := 
Module[ {n,Sl,edfr,edbr,edfl,edbl,wit,Sr,edger,edgel,perm,Gr,Gl,Glr},
	n = SemigroupDegree[gen];
	{Sr,edfr,edbr,wit} = GenerateSemigroup[gen,Direction->Right,Full->False,opts];
	edger = Join[edfr,edbr];
	{Sl,edfl,edbl,wit} = GenerateSemigroup[gen,Direction->Left,Full->False,opts];
	edgel = Join[edfl,edbl];
	Assert[ Sort[Sr]===Sort[Sl] ];
	perm = PermutationList[ FindPermutation[ Sl, Sr ], Length[Sr] ];
	Gr = TransitionsToGraph[ n, edger ];
	Gl = TransitionsToGraph[ n, MapTransitions[ edgel, perm[[#]]& ] ];
	Glr = GraphUnion[Gl,Gr];
	{Sr,ConnectedComponents /@ {Gl,Gr,Glr},wit,edbr}
];	


(* ::Section::Closed:: *)
(*Footer*)


(* ::Text:: *)
(*Ultimately place args/protect stuff here. *)


$defaultnormalize::args = "Wrong argument(s), try $defaultnormalize";
(*$defaultnormalize[__] := $Failed /; Message[$defaultnormalize::args];*)
(*Normalize::args = "Wrong argument(s), try Normalize ";
Normalize[__] := $Failed /; Message[Normalize::args];*)
$alphabet::args = "Wrong argument(s), try $alphabet";
(*$alphabet[__] := $Failed /; Message[$alphabet::args];*)
Simple::args = "Wrong argument(s), try Simple ";
Simple[__] := $Failed /; Message[Simple::args];
Props::args = "Wrong argument(s), try Props";
Props[__] := $Failed /; Message[Props::args];
Labels::args = "Wrong argument(s), try Labels ";
Labels[__] := $Failed /; Message[Labels::args];
Trim::args = "Wrong argument(s), try Trim";
Trim[__] := $Failed /; Message[Trim::args];
Accessible::args = "Wrong argument(s), try Accessible ";
Accessible[__] := $Failed /; Message[Accessible::args];
Coaccessible::args = "Wrong argument(s), try Coacessible";
Coaccessible[__] := $Failed /; Message[Coaccessible::args];
DoTrace::args = "Wrong argument(s), try DoTrace ";
DoTrace[__] := $Failed /; Message[DoTrace::args];
EpsElim::args = "Wrong argument(s), try EpsElim";
EpsElim[__] := $Failed /; Message[EpsElim::args];
Printable::args = "Wrong argument(s), try Printable ";
Printable[__] := $Failed /; Message[Printable::args];
AlphabetOffset::args = "Wrong argument(s), try AlphabetOffset";
AlphabetOffset[__] := $Failed /; Message[AlphabetOffset::args];
Letter::args = "Wrong argument(s), try Letter ";
Letter[__] := $Failed /; Message[Letter::args];
Digit::args = "Wrong argument(s), try Digit";
Digit[__] := $Failed /; Message[Digit::args];
States::args = "Wrong argument(s), try States ";
States[__] := $Failed /; Message[States::args];
StatesNorm::args = "Wrong argument(s), try StatesNorm";
StatesNorm[__] := $Failed /; Message[StatesNorm::args];
AlphabetNorm::args = "Wrong argument(s), try AlphabetNorm ";
AlphabetNorm[__] := $Failed /; Message[AlphabetNorm::args];
Sorted::args = "Wrong argument(s), try Sorted";
Sorted[__] := $Failed /; Message[Sorted::args];
Strict::args = "Wrong argument(s), try Strict ";
Strict[__] := $Failed /; Message[Strict::args];
SizeOnly::args = "Wrong argument(s), try SizeOnly";
SizeOnly[__] := $Failed /; Message[SizeOnly::args];
Terminal::args = "Wrong argument(s), try Terminal ";
Terminal[__] := $Failed /; Message[Terminal::args];
Words::args = "Wrong argument(s), try Words";
Words[__] := $Failed /; Message[Words::args];
VertexTransformation::args = "Wrong argument(s), try VertexTransformation ";
VertexTransformation[__] := $Failed /; Message[VertexTransformation::args];
LabelTransformation::args = "Wrong argument(s), try LabelTransformation";
LabelTransformation[__] := $Failed /; Message[LabelTransformation::args];
Alpha::args = "Wrong argument(s), try Alpha[k]";
(*Alpha[__] := $Failed /; Message[Alpha::args];*)
GetAlphabet::args = "Wrong argument(s), try GetAlphabet[T]";
GetAlphabet[__] := $Failed /; Message[GetAlphabet::args];
AlphabetCount::args = "Wrong argument(s), try AlphabetCount[A]";
AlphabetCount[__] := $Failed /; Message[AlphabetCount::args];
AlphabetTracks::args = "Wrong argument(s), try AlphabetTracks[A]";
AlphabetTracks[__] := $Failed /; Message[AlphabetTracks::args];
AlphabetTrackCount::args = "Wrong argument(s), try AlphabetTrackCount[A]";
AlphabetTrackCount[__] := $Failed /; Message[AlphabetTrackCount::args];
AlphabetList::args = "Wrong argument(s), try AlphabetList[A]";
AlphabetList[__] := $Failed /; Message[AlphabetList::args];
Eps::args = "Wrong argument(s), try Eps ";
Eps[__] := $Failed /; Message[Eps::args];
EpsQ::args = "Wrong argument(s), try EpsQ[x]";
EpsQ[__] := $Failed /; Message[EpsQ::args];
WordQ::args = "Wrong argument(s), try WordQ[x]";
WordQ[__] := $Failed /; Message[WordQ::args];
ToWord::args = "Wrong argument(s), try ToWord[w,A]";
ToWord[__] := $Failed /; Message[ToWord::args];
ToIndex::args = "Wrong argument(s), try ToIndex[w,A]";
ToIndex[__] := $Failed /; Message[ToIndex::args];
Randomword::args = "Wrong argument(s), try RandomWord[k,A]";
Randomword[__] := $Failed /; Message[Randomword::args];
WordBinomial::args = "Wrong argument(s), try WordBinomial[u,v,opts]";
WordBinomial[__] := $Failed /; Message[WordBinomial::args];
WordLength::args = "Wrong argument(s), try WordLength[w]";
WordLength[__] := $Failed /; Message[WordLength::args];
WordSort::args = "Wrong argument(s), try WordSort[L]";
WordSort[__] := $Failed /; Message[WordSort::args];
WordShuffle::args = "Wrong argument(s), try WordShuffle[u,v]";
WordShuffle[__] := $Failed /; Message[WordShuffle::args];
(*TSys::args = "Wrong argument(s), try TSys[n,k,t,tr,K,opts]";
TSys[__] := $Failed /; Message[TSys::args];*)
TransitionSource::args = "Wrong argument(s), try TransitionSource[t]";
TransitionSource[__] := $Failed /; Message[TransitionSource::args];
TransitionLabel::args = "Wrong argument(s), try TransitionLabel[t]";
TransitionLabel[__] := $Failed /; Message[TransitionLabel::args];
TransitionTarget::args = "Wrong argument(s), try TransitionTarget[t]";
TransitionTarget[__] := $Failed /; Message[TransitionTarget::args];
TransitionCount::args = "Wrong argument(s), try TransitionCount[T]";
TransitionCount[__] := $Failed /; Message[TransitionCount::args];
TransitionsRaw::args = "Wrong argument(s), try TransitionsRaw[T]";
TransitionsRaw[__] := $Failed /; Message[TransitionsRaw::args];
TransitionList::args = "Wrong argument(s), try TransitionList[T]";
TransitionList[__] := $Failed /; Message[TransitionList::args];
StateCount::args = "Wrong argument(s), try StateCount[T]";
StateCount[__] := $Failed /; Message[StateCount::args];
StateList::args = "Wrong argument(s), try StateList[T]";
StateList[__] := $Failed /; Message[StateList::args];
SetTransitionSystem::args = "Wrong argument(s), try SetTransitionSystem[M,T]";
SetTransitionSystem[__] := $Failed /; Message[SetTransitionSystem::args];
SetStates::args = "Wrong argument(s), try SetStates[T,Q]";
SetStates[__] := $Failed /; Message[SetStates::args];
SetAlphabet::args = "Wrong argument(s), try SetAlphabet[T,A]";
SetAlphabet[__] := $Failed /; Message[SetAlphabet::args];
StateDelete::args = "Wrong argument(s), try StateDelete[T,p,opts]";
StateDelete[__] := $Failed /; Message[StateDelete::args];
EpsilonFreeQ::args = "Wrong argument(s), try EpsilonFreeQ[T]";
EpsilonFreeQ[__] := $Failed /; Message[EpsilonFreeQ::args];
FullProductTransitions::args = "Wrong argument(s), try FullProductTransitions[T1,T2]";
FullProductTransitions[__] := $Failed /; Message[FullProductTransitions::args];
ProductTransitionSystem::args = "Wrong argument(s), try ProductTransitionSystem[T1,T2]";
ProductTransitionSystem[__] := $Failed /; Message[ProductTransitionSystem::args];
MapTransitions::args = "Wrong argument(s), try MapTransitions[tr,f,g]";
MapTransitions[__] := $Failed /; Message[MapTransitions::args];
TransitionFunctionList::args = "Wrong argument(s), try TransitionFunctionList[ff,T]";
TransitionFunctionList[__] := $Failed /; Message[TransitionFunctionList::args];
AssignTransitionFunction::args = "Wrong argument(s), try AssignTransitionFunction[del,T]";
AssignTransitionFunction[__] := $Failed /; Message[AssignTransitionFunction::args];
TransitionMatrix::args = "Wrong argument(s), try TransitionMatrix[T]";
TransitionMatrix[__] := $Failed /; Message[TransitionMatrix::args];
TransitionsToSparse::args = "Wrong argument(s), try TransitionsToSparse[T]";
TransitionsToSparse[__] := $Failed /; Message[TransitionsToSparse::args];
TransitionToBooleanMatrix::args = "Wrong argument(s), try TransitionToBooleanMatrix[T]";
TransitionToBooleanMatrix[__] := $Failed /; Message[TransitionToBooleanMatrix::args];
SubTransitionSystem::args = "Wrong argument(s), try SubTransitionSystem[T,P]";
SubTransitionSystem[__] := $Failed /; Message[SubTransitionSystem::args];
ReverseTransitions::args = "Wrong argument(s), try ReverseTransitions[T]";
ReverseTransitions[__] := $Failed /; Message[ReverseTransitions::args];
FSMQ::args = "Wrong argument(s), try FSMQ[M]";
FSMQ[__] := $Failed /; Message[FSMQ::args];
AccCond::args = "Wrong argument(s), try AccCond[args]";
AccCond[__] := $Failed /; Message[AccCond::args];
(*FA::args = "Wrong argument(s), try FA[args]";
FA[__] := $Failed /; Message[FA::args];*)
(*DFA::args = "Wrong argument(s), try DFA[args]";
DFA[__] := $Failed /; Message[DFA::args];*)
(*TD::args = "Wrong argument(s), try TD[args]";
TD[__] := $Failed /; Message[TD::args];*)
TransitionSystem::args = "Wrong argument(s), try TransitionSystem[A]";
TransitionSystem[__] := $Failed /; Message[TransitionSystem::args];
InitialStateList::args = "Wrong argument(s), try InitialStateList[T]";
InitialStateList[__] := $Failed /; Message[InitialStateList::args];
InitialState::args = "Wrong argument(s), try InitialState[M]";
InitialState[__] := $Failed /; Message[InitialState::args];
FinalStateList::args = "Wrong argument(s), try StateList[T]";
FinalStateList[__] := $Failed /; Message[FinalStateList::args];
TrapStateList::args = "Wrong argument(s), try TrapStateList[M]";
TrapStateList[__] := $Failed /; Message[TrapStateList::args];
TypeFSM::args = "Wrong argument(s), try TypeFSM[A]";
TypeFSM[__] := $Failed /; Message[TypeFSM::args];
TrimStateList::args = "Wrong argument(s), try TrimStateList[M,opts]";
TrimStateList[__] := $Failed /; Message[TrimStateList::args];
TrimFA::args = "Wrong argument(s), try TrimFA[M,opts]";
TrimFA[__] := $Failed /; Message[TrimFA::args];
ToFA::args = "Wrong argument(s), try ToFA[M]";
ToFA[__] := $Failed /; Message[ToFA::args];
SetInitialFA::args = "Wrong argument(s), try SetInitialFA[M,I]";
SetInitialFA[__] := $Failed /; Message[SetInitialFA::args];
SetFinalFA::args = "Wrong argument(s), try SetFinalFA[M,F]";
SetFinalFA[__] := $Failed /; Message[SetFinalFA::args];
SetInitialFinalFA::args = "Wrong argument(s), try SetInitialFinalFA[M,I,F]";
SetInitialFinalFA[__] := $Failed /; Message[SetInitialFinalFA::args];
ToAllFA::args = "Wrong argument(s), try ToAllFA[M]";
ToAllFA[__] := $Failed /; Message[ToAllFA::args];
SubFA::args = "Wrong argument(s), try SubFA[M,P]";
SubFA[__] := $Failed /; Message[SubFA::args];
UniversalDFA::args = "Wrong argument(s), try UniversalDFA[A]";
UniversalDFA[__] := $Failed /; Message[UniversalDFA::args];
GenerateFA::args = "Wrong argument(s), try GenerateFA[Q0,{f,g,..},A,fin]";
GenerateFA[__] := $Failed /; Message[GenerateFA::args];
CounterDFA::args = "Wrong argument(s), try CounterDFA[a,n,A,opts]";
CounterDFA[__] := $Failed /; Message[CounterDFA::args];
PositionFA::args = "Wrong argument(s), try PositionFA[a,n,A,opts]";
PositionFA[__] := $Failed /; Message[PositionFA::args];
CirculantFA::args = "Wrong argument(s), try CirculantFA[n,{s1,...,sk],opts]";
CirculantFA[__] := $Failed /; Message[CirculantFA::args];
SubwordCounterDFA::args = "Wrong argument(s), try SubwordCounterDFA[w,p,A,opts]";
SubwordCounterDFA[__] := $Failed /; Message[SubwordCounterDFA::args];
ToFactorFA::args = "Wrong argument(s), try ToFactorFA[M,opts]";
ToFactorFA[__] := $Failed /; Message[ToFactorFA::args];
ToFrontierDFA::args = "Wrong argument(s), try ToFrontierDFA[M,opts]";
ToFrontierDFA[__] := $Failed /; Message[ToFrontierDFA::args];
TransitionsToEdges::args = "Wrong argument(s), try TransitionsToEdges[t,opts]";
TransitionsToEdges[__] := $Failed /; Message[TransitionsToEdges::args];
TransitionsToGraph::args = "Wrong argument(s), try TransitionsToGraph[t,opts]";
TransitionsToGraph[__] := $Failed /; Message[TransitionsToGraph::args];
NonTrivialComponentQ::args = "Wrong argument(s), try NonTrivialComponentQ[G,L]";
NonTrivialComponentQ[__] := $Failed /; Message[NonTrivialComponentQ::args];
CondensationGraph::args = "Wrong argument(s), try CondensationGraph[G]";
CondensationGraph[__] := $Failed /; Message[CondensationGraph::args];
ShowGraph::args = "Wrong argument(s), try ShowGraph[G,opts]";
ShowGraph[__] := $Failed /; Message[ShowGraph::args];
ApplyTransduction::args = "Wrong argument(s), try ApplyTransduction[T,L,opts]";
ApplyTransduction[__] := $Failed /; Message[ApplyTransduction::args];
AssignTransduction::args = "Wrong argument(s), try AssignTransduction[t,T,opts]";
AssignTransduction[__] := $Failed /; Message[AssignTransduction::args];
ToKernelFA::args = "Wrong argument(s), try ToKernelFA[A,K,opts]";
ToKernelFA[__] := $Failed /; Message[ToKernelFA::args];
TestPropertyFA::args = "Wrong argument(s), try TestPropertyFA[A,P,opts]";
TestPropertyFA[__] := $Failed /; Message[TestPropertyFA::args];
ReverseFA::args = "Wrong argument(s), try ReverseFA[M]";
ReverseFA[__] := $Failed /; Message[ReverseFA::args];
EpsilonEliminationFA::args = "Wrong argument(s), try EpsilonEliminationFA[M]";
EpsilonEliminationFA[__] := $Failed /; Message[EpsilonEliminationFA::args];
DeterminizeFA::args = "Wrong argument(s), try DeterminizeFA[M]";
DeterminizeFA[__] := $Failed /; Message[DeterminizeFA::args];
LanguageFA::args = "Wrong argument(s), try LanguageFA[M,n,opts]";
LanguageFA[__] := $Failed /; Message[LanguageFA::args];
MinimizeFA::args = "Wrong argument(s), try MinimizeFA[M,opts]";
MinimizeFA[__] := $Failed /; Message[MinimizeFA::args];
MinimizeDFA::args = "Wrong argument(s), try MinimizeDFA[M,opts]";
MinimizeDFA[__] := $Failed /; Message[MinimizeDFA::args];
ComplementFA::args = "Wrong argument(s), try ComplementFA[M]";
ComplementFA[__] := $Failed /; Message[ComplementFA::args];
ConcatenateFA::args = "Wrong argument(s), try ConcatenateFA[M]";
ConcatenateFA[__] := $Failed /; Message[ConcatenateFA::args];
StarFA::args = "Wrong argument(s), try StarFA[M]";
StarFA[__] := $Failed /; Message[StarFA::args];
IntersectionFA::args = "Wrong argument(s), try IntersectionFA[M1,M2]";
IntersectionFA[__] := $Failed /; Message[IntersectionFA::args];
ProductFA::args = "Wrong argument(s), try ProductFA[M1,M2]";
ProductFA[__] := $Failed /; Message[ProductFA::args];
UnionFA::args = "Wrong argument(s), try UnionFA[M1,M2]";
UnionFA[__] := $Failed /; Message[UnionFA::args];
ShuffleProductFA::args = "Wrong argument(s), try ShuffleProductFA[M1,M2,opts]";
ShuffleProductFA[__] := $Failed /; Message[ShuffleProductFA::args];
GrowthFunctionDFA::args = "Wrong argument(s), try GrowthSeriesDFA[M,x]";
GrowthFunctionDFA[__] := $Failed /; Message[GrowthFunctionDFA::args];
EmptyQFA::args = "Wrong argument(s), try EmptyQFA[M]";
EmptyQFA[__] := $Failed /; Message[EmptyQFA::args];
FiniteQFA::args = "Wrong argument(s), try FiniteQFA[M]";
FiniteQFA[__] := $Failed /; Message[FiniteQFA::args];
DeterministicQFA::args = "Wrong argument(s), try DeterministicQFA[M]";
DeterministicQFA[__] := $Failed /; Message[DeterministicQFA::args];
DefiniteQDFA::args = "Wrong argument(s), try DefiniteQDFA[M]";
DefiniteQDFA[__] := $Failed /; Message[DefiniteQDFA::args];
UniversalQFA::args = "Wrong argument(s), try UniversalQFA[M]";
UniversalQFA[__] := $Failed /; Message[UniversalQFA::args];
EquivalentQFA::args = "Wrong argument(s), try EquivalentQFA[M1,M2]";
EquivalentQFA[__] := $Failed /; Message[EquivalentQFA::args];
IsomorphicQDFA::args = "Wrong argument(s), try IsomorphicQDFA[M1,M2]";
IsomorphicQDFA[__] := $Failed /; Message[IsomorphicQDFA::args];
CoverQDFA::args = "Wrong argument(s), try CoverQDFA[M1,M2,opts]";
CoverQDFA[__] := $Failed /; Message[CoverQDFA::args];
AssignHomomorphismDFA::args = "Wrong argument(s), try AssignHomomorphismDFA[M1,M2]";
AssignHomomorphismDFA[__] := $Failed /; Message[AssignHomomorphismDFA::args];
(*$regexrules::args = "Wrong argument(s), try $regexrules";
$regexrules[__] := $Failed /; Message[$regexrules::args];*)
SGT::args = "Wrong argument(s), try SGT[L]";
SGT[_,__] := $Failed /; Message[SGT::args];
SemigroupProduct::args = "Wrong argument(s), try SemigroupProduct[x,y]";
SemigroupProduct[__] := $Failed /; Message[SemigroupProduct::args];
SemigroupPower::args = "Wrong argument(s), try SemigroupPower[T,k]";
SemigroupPower[__] := $Failed /; Message[SemigroupPower::args];
TransformationQ::args = "Wrong argument(s), try TransformationQ[L]";
TransformationQ[__] := $Failed /; Message[TransformationQ::args];
PermutationToTransformation::args = "Wrong argument(s), try PermutationToTransformation[p,n]";
PermutationToTransformation[__] := $Failed /; Message[PermutationToTransformation::args];
ToTransformationsDFA::args = "Wrong argument(s), try ToTransformationsDFA[M]";
ToTransformationsDFA[__] := $Failed /; Message[ToTransformationsDFA::args];
GenerateSemigroup::args = "Wrong argument(s), try GenerateSemigroup[{t1,..,tk},opts]";
GenerateSemigroup[__] := $Failed /; Message[GenerateSemigroup::args];



End[];
EndPackage[];
