(* ::Package:: *)

BeginPackage["Automata11`"];
EndPackage[];


(* load the package and experimental code *)

(*  carefule with Catch/Throw bug
    http://mathematica.stackexchange.com/questions/84539/possible-bug-of-loading-package-mathematica-10-1
*)

initload::error = "Load `1` failed.";
initload::done  = "Automata11 loaded (utils, fsm, experimental, plot, cellaut, sgroup).";

With[ {kern = ToFileName[ {$UserBaseDirectory, "Applications", "Automata11", "Kernel"}]},

If[ Needs["Automata11`utils`", ToFileName[ {kern}, "utils.m" ]] === $Failed,
    Message[initload::error,"utils 11"] ];

If[ Needs["Automata11`fsm`", ToFileName[ {kern}, "fsm.m" ]] === $Failed,
    Message[initload::error,"fsm 11"] ]; 

If[ Needs["Automata11`experimental`", ToFileName[ {kern}, "experimental.m" ]] === $Failed,
    Message[initload::error,"experimental 11"] ]; 

If[ Needs["Automata11`plot`", ToFileName[ {kern}, "plot.m" ]] === $Failed,
    Message[initload::error,"plot 11"] ]; 

If[ Needs["Automata11`cellaut`", ToFileName[ {kern}, "cellaut.m" ]]  === $Failed,
    Message[initload::error,"cellaut 11"] ]; 

If[ Needs["Automata11`sgroup`", ToFileName[ {kern}, "sgroup.m" ]] === $Failed,
    Message[initload::error,"sgroup 11"] ]; 
];

Message[initload::done];

(* eof *)

